/**
 * Created by kinfen on 16/7/26.
 */
import React from 'react';
import ReactDOM from 'react-dom';
import Component from './components/KComponent';
import {
	Layout,
	Menu,
	Row,
	Col,
	Icon,
} from 'antdlib';
const SubMenu = Menu.SubMenu;
const { Header, Sider, Content, Footer } = Layout;
import FooterContent from './components/Footer';

import {control} from 'kadm-component';
import {Modal, Loading} from './components/utilsForReactDom';
import { connect } from 'react-redux';
import { Link } from 'react-router';
import UserPanel from './components/UserPanel';
import PropTypes from 'prop-types';

import {
	selecteModule
} from './action'
import reduxMng from 'kadm-redux-mng';
var store = reduxMng.getStore();
class App extends Component{

	constructor(props) {
		super(props);
	}
	componentDidMount(){
		control.init();

	}

	getChildContext(){
		return {
			router:this.context.router,
			adminPath:KAdm.adminPath,
		}
	}

	state = {
		collapsed: false,
	};

	toggle = () => {
		this.setState({
			collapsed: !this.state.collapsed,
		});
	}
	renderTreeMenu(modules, level){
		var list = [];
		if (modules.length > 0)
		{
			var self = this;
			_.each(modules, function(element, index){
				let subNods;
				let rightItem;
				if (element.childs && element.childs.length > 0)
				{
					subNods = (
						<Menu.SubMenu key={element._id} title={<span><Icon type={element.icon} /><span>{element.name}</span></span>} >
							{self.renderTreeMenu(element.childs, level + 1)}
						</Menu.SubMenu>);
					list.push(subNods);

				}
				else {
					var link = element.link ? element.link + "?module=" + element._id : "#";
					list.push(
						<Menu.Item key={element._id}>

							<Link to={link} onClick={() => store.dispatch(selecteModule(element))}>
								<Icon type={element.icon} />
								<span>{element.name}</span>
							</Link>
						</Menu.Item>
					);
				}

			});
		}

		return list;
	}
	render(){

		const LogoB = <span><strong>K</strong></span>;
		
		const LogoS = <span><strong>KA</strong>dmin</span>;

		return (
			<Layout>
				<Sider
					trigger={null}
					collapsible
					collapsed={this.state.collapsed}
				>

					<Header className="logo slider-header" >
						{
							this.state.collapsed ? LogoB : LogoS
						}
					</Header>
					<Menu
						defaultSelectedKeys={['0']}
						mode="inline"
						theme="dark"
						inlineCollapsed={this.state.collapsed}
					>
						{this.renderTreeMenu(this.props.modules, 0)}
					</Menu>
				</Sider>
				<Layout >
					<Header theme="dark" className="main-header">
						<Row >
							<Col span={4} >
								<Icon
									className="trigger"
									size="large"
									type={this.state.collapsed ? 'menu-unfold' : 'menu-fold'}
									onClick={this.toggle}
								/>
							</Col>
							<Col span={20} style={{
								display:'flex',
								flexDirection:'row',
								justifyContent:'flex-end',
							}}>
								<UserPanel router={this.context.router}/>
							</Col>
						</Row>


					</Header>
					<Content style={{
						minHeight:'500px',
					}}>
						<Loading loading={this.props.loading}/>
						{this.props.children}
					</Content>
					<Footer>
						<FooterContent/>
					</Footer>
				</Layout>
			</Layout>
		)

	}

};
App.contextTypes = {
	router: PropTypes.object.isRequired,
};
App.childContextTypes = {
	router: PropTypes.object.isRequired,
	adminPath:PropTypes.string.isRequired,
};
export default connect((state) => {
	return {
		modules:state.app.modules,
		loading:state.app.mainloading
	}
})(App);
