/**
 * Created by kinfen on 16/7/27.
 */
'use strict';
import React from 'react';
import {
	Breadcrumb,
	Icon,
	Row,
	Col,

} from 'antdlib';
import { Link } from 'react-router';
import _ from 'lodash';
import { connect } from 'react-redux';
class ContentHeader extends React.Component{

	lookInDeep(modules, id, arrayPoll){
		for (var i = 0; i < modules.length; i++){
			let o = modules[i];
			if (o._id != id && o.childs) {
				let res = this.lookInDeep(o.childs, id, arrayPoll);
				if (res) return arrayPoll.push(o);
			} else if (o._id === id) {
				return arrayPoll.push(o);
			}
		}
		return undefined;
	}
	render(){
		var component;
		if (this.props.component){
			component = this.props.component;
		} else {
			var pools = [];
			if(this.props.selectedModule){
				this.lookInDeep(this.props.modules, this.props.selectedModule._id, pools);
				_.reverse(pools);
			}
			
			component = (
				<Breadcrumb>
					<Breadcrumb.Item>
						<Link to={'/' + KAdm.adminPath}><Icon type="home" /></Link>
					</Breadcrumb.Item>
					{
						_.map(pools, (o) => {
							return (
								<Breadcrumb.Item key={o._id}>
									<Icon type={o.icon} />
									<span><Link to={o.link}>{o.name}</Link></span>
								</Breadcrumb.Item>
							)
						})
					}
				</Breadcrumb>
			)
		}
		
		return (
			<section>
				<Row >
					<Col span="10">
						<h1>
							{this.props.label ? this.props.label : '模块内容'}
							<small>{this.props.sublable ? this.props.sublable : '列表'}</small>
						</h1>
					</Col>
					<Col span="14" style={{
						height: '54px',
						display: 'flex',
						justifyContent: 'flex-end',
						alignItems: 'center',
					}}>
						{component}
						
					</Col>

				</Row>
			</section>
		);
	}

};

export default connect((state) => {
	return {
		modules:state.app.modules,
		selectedModule:state.app.selectedModule
	}
})(ContentHeader);
