/**
 * Created by kinfen on 16/7/26.
 */
import assign from 'object-assign';
const initialState = {
	data: null,
	id: null,
	loading: true,
	ready: false,
	error: null,
};
import {
	ITEM_SELECT,
	ITEM_DATA_LOADING_SUCCESS,
	ITEM_DELETE,
	ITEM_LOAD_DATA,
	ITEM_PROCESS_ERROR,
	ITEM_CREATE,
	ITEM_CREATE_SUCCESS,
	ITEM_CREATE_FAIL,
} from './actions';

function item (state = initialState, action) {
	switch (action.type) {
		case ITEM_SELECT:
			return assign({}, state, {
				id:action.id,
				data:null,
			});
		case ITEM_LOAD_DATA:
			return assign({}, state, {
				loading: true,
			});
		case ITEM_DATA_LOADING_SUCCESS:
			var obj = assign({}, state, {
				data: action.data,
				loading: false,
				ready: true,
				error: null,
			});
			return obj
		case ITEM_PROCESS_ERROR:
			return assign({}, state, {
				data: null,
				loading: false,
				ready: true,
				error: action.error,
			});
		case ITEM_CREATE_SUCCESS:
			return assign({}, state, {
				createData: action.createData,
			});
		case ITEM_CREATE_FAIL:
			return assign({}, state, {
				error: action.err,
			});
		default:
			return state;
	}
}

export default item;
