/**
 * Created by kinfen on 16/8/19.
 */

import {
	loadDataFromState,
	listPage,
} from "../actions";

/**
 * Active actions
 */
export const LIST_SET_ACTIVE_SEARCH = "LIST_SET_ACTIVE_SEARCH";
export function setActiveSearch (searchString) {
	return {
		type: LIST_SET_ACTIVE_SEARCH,
		searchString,
	};
}

export const LIST_SET_ACTIVE_SORT = "LIST_SET_ACTIVE_SORT";
export function setActiveSort (path) {
	return (dispatch, getState) => {
		// TODO Decouple from state somehow
		const list = getState().lists.currentModel;
		const sort = list.expandSort(path);
		dispatch({
			type: LIST_SET_ACTIVE_SORT,
			sort,
		});
	};
}


export const LIST_SET_ACTIVE_COLUMNS = "LIST_SET_ACTIVE_COLUMNS";
export function setActiveColumns (columns) {
	return (dispatch, getState) => {
		// TODO Decouple from state somehow
		const list = getState().lists.currentModel;
		const expandedColumns = list.expandColumns(columns);
		dispatch({
			type: LIST_SET_ACTIVE_COLUMNS,
			columns: expandedColumns,
		});
	};
}


export const LIST_SET_ACTIVE_LIST = "LIST_SET_ACTIVE_LIST";
export function setActiveList (list, id) {
	return {
		type: LIST_SET_ACTIVE_LIST,
		list,
		id,
	};
}

/**
 * Filtering actions
 */
export const LIST_ADD_FILTER = "LIST_ADD_FILTER";
function addFilter (filter) {
	// TODO Make this a pure function again, find better way to call loadItems()
	// after each filtering change!
	return (dispatch) => {
		dispatch({
			type: LIST_ADD_FILTER,
			filter,
		});
	};
}


export const LIST_CLEAR_FILTER = "LIST_CLEAR_FILTER";
export function clearFilter (path) {
	// TODO Make this a pure function again, find better way to call loadItems()
	// after each filtering change!
	return (dispatch) => {
		dispatch({
			type: LIST_CLEAR_FILTER,
			path,
		});
		dispatch(loadDataFromState());
	};
}

export const LIST_CLEAR_ALL_FILTERS = "LIST_CLEAR_ALL_FILTERS";
export function clearAllFilters () {
	// TODO Make this a pure function again, find better way to call loadItems()
	// after each filtering change!
	return (dispatch) => {
		dispatch({
			type: LIST_CLEAR_ALL_FILTERS,
		});
		dispatch(loadDataFromState());
	};
}


export function setFilter (path, value) {
	return (dispatch, getState) => {
		const state = getState();
		const activeFilters = state.active.filters;
		const currentList = state.lists.currentModel;
		const page = state.lists.page;
		// Get current filter
		let filter = activeFilters.filter(i => i.field.path === path)[0];
		// If a filter exists already, update its value
		if (filter) {
			filter.value = value;
			// Otherwise construct a new one
		} else {
			const field = currentList.fields[path];
			if (!field) {
				console.warn('Invalid Filter path specified:', path);
				return;
			}
			filter = {
				field,
				value,
			};
		}
		dispatch(addFilter(filter));
		dispatch(listPage({
			index:1,
			size:page.size,
		}));
	};
}
