/**
 * Created by kinfen on 2017/5/19.
 */
import React from 'react';
import ReactDOM from 'react-dom';
import _ from "lodash";
import { Fields} from "FieldTypes";

import {
	itemCreate,
} from '../../itemview/actions'
import {
	Form,
	Button,
	Input,
	Modal,
	Alert,
} from 'antdlib';



class _createForm extends React.Component {
	constructor(props){
		super(props)
		this.state = {
			layout:"horizontal"
		}
	}
	getProps (field) {
		let props = _.assign({}, field);


		props.layout = this.state.layout;
		props.formItemLayout = props.layout == "horizontal" ? {
			labelCol: { span: 4 },
			wrapperCol: { span: 14 },
		} : null;
		props.form = this.props.form;
		return props;
	}
	render(){
		var modelObj = this.props.model;
		var initFields = modelObj.initialFields;
		var fieldList = [];

		for (var i = 0; i < initFields.length; i++){
			let field = initFields[i];
			var fieldObj = modelObj.fields[field];


			fieldObj.mode = 'create';
			fieldObj.onChange = () => {}
			fieldObj.key = fieldObj.path;

			//fieldObj.defaultValue = ['582c1c7244813e0af63668f5'];
			fieldObj = this.getProps(fieldObj);
			fieldObj.ref = 'field_ref_' + field;
			var type = fieldObj.type;
			var cobj =  Fields[type];
			fieldList.push(
				React.createElement(cobj, fieldObj)
			);

		}
		var node = (
			<Form type={this.state.layout } layout={this.state.layout } id="table-create" >
					{fieldList}
			</Form>
		);

		return node;
	}
}

class ItemCreateModal extends React.Component {

	constructor(props){
		super(props);

		var modelObj = this.props.model;

		this.state = _.assign(super.state, {
			loading:false,
			created:false,
			data:null,
			error:null,
			type: "default",
			title:"创建一个" + modelObj.singular,
		});
	}
	componentDidMount(){


	}
	errorInfoClose(e){
		delete this.state.error;
	}
	show(){
		this.setState({
			show:true,
		})
	}
	hide(){
		this.handleCancel();
	}
	handleCancel(){
		this.setState({
			show:false,
			error:null,
			created:false,
		})
		if (this.state.created && this.props.successAndClose){
			this.props.successAndClose();
		}
	}
	handleEdit(){
		if (this.props.successAndEdit){
			this.props.successAndEdit(this.state.data);
		}
	}
	submitHandler(e){

		var modelObj = this.props.model;
		if (this.props.isNeedCreateParams && !this.props.params){

			this.setState({
				error:"缺少默认过滤项",
			});
			return;
		}

		// Recommended
		// this.formRef

		this.refs.form.validateFields((err, values) => {
			if (!err) {
				//console.log('Received values of form: ', values);
				let formData = new FormData();
				_.forEach(values, (value, key) => {

					if (Array.isArray(value) && value.length == 0){
						//远择下拉类，如果子元素为0，表格不传值
						return;
					}
					else if (typeof value == 'object' && value != null && (value._isAMomentObject || value._JSONObject)){
						//时间类元母，执行field的format
						value = value.format();
					} else if (typeof value == 'object' && value != null) {
						//const fieldType = Fields[this.props.list.fields[key].type];

						value = this.formRef.refs['field_ref_' + key].format();
					}
					formData.append(key, value)
				});

				if (this.props.params){
					formData.append(this.props.params.filter, this.props.params.value);
				}
				
				this.setState({
					loading:true,
				})
				this.props.store.dispatch(itemCreate(formData, (err, data) => {

					if (data){
						this.setState({
							created:true,
							data,
						})
					}
					this.setState({
						loading:false,
					})
				}));
			}
			else {
				this.setState({
					loading:false,
				})

			}
		});

	}
	render(){

		var cancelBtn = <Button size="large" onClick={this.handleCancel.bind(this)} key='cancel'>取消</Button>;
		var createBtn = <Button type="primary" size="large" loading={this.state.loading} onClick={this.submitHandler.bind(this)} key='create'>创建</Button>
		var editBtn = <Button type="primary" size="large" onClick={this.handleEdit.bind(this)} key='edit'>编辑</Button>
		let CForm = Form.create({
		})(_createForm);

		var formNode = this.state.created? <p>成功创建</p> : <CForm ref="form" {...this.props}
																	wrappedComponentRef={(inst) => this.formRef = inst}/>;

		var alertNode = this.state.error ? <Alert
			message="错误"
			description={this.state.error}
			type="error"
			showIcon
			closable
			onClose={this.errorInfoClose.bind(this)}
		/> : null;

		return (
			<Modal
				visible={this.state.show}
				title={this.state.title}
				onCancel={this.handleCancel.bind(this)}
				footer={[this.state.created? editBtn:createBtn, cancelBtn]}
			>
				{alertNode}
				{formNode}
			</Modal>
		)
	}

}
export default  ItemCreateModal;
