import React, { PropTypes } from 'react';
import Chip from '../../Chip';
import Filter from './Filter';
import {
	setFilter,
	LIST_CLEAR_ALL_FILTERS,
	clearAllFilters,
} from '../active/actions'
import { loadDataFromState } from '../actions';

class ListFilters extends React.Component{
	constructor(props){
		super(props)
	}

	
	render(){
		if (!this.props.filters.length) return <div />;

		const dispatchClearAllFilters = () => {

			
			if (this.props.hideFilters.length === 1){
				this.props.dispatch({
					type: LIST_CLEAR_ALL_FILTERS,
				});
				let filter = _.find(this.props.filters, (o) => o.field.path === this.props.hideFilters[0]);
				if (filter){
					this.props.dispatch(setFilter(filter.field.path, {
						inverted:false,
						value:filter.value.value
					}));
				}
				this.props.dispatch(loadDataFromState());
			} else {
				this.props.dispatch(clearAllFilters());
			}
		};
		// Generate the list of filter pills
		//key change to f-value to make Filter render again
		let currentFilters = this.props.filters.map((filter, i) => (
			//return filter who not in hide list;
			this.props.hideFilters.indexOf(filter.field.path) == -1 ? <Filter
				key={'f-' + filter.field.path + "-" + filter.value.value[0] || i}
				filter={filter}
				dispatch={this.props.dispatch}
			/> : null
		));

		currentFilters = _.pull(currentFilters, null);

		// When more than 1, append the clear button
		if (currentFilters.length > 1) {
			currentFilters.push(
				<Chip
					key="listFilters__clear"
					label="清除所有"
					onClick={dispatchClearAllFilters}
				/>
			);
		}
		const styles = {
			marginBottom: '1em',
			marginTop: '1em',
			display:'flex',
			flexFlow:'row wrap',

		};
		return (
			<div style={styles}>
				{currentFilters}
			</div>
		);
	}
	
};

ListFilters.propTypes = {
	dispatch: PropTypes.func.isRequired,
	filters: PropTypes.array.isRequired,
	hideFilters:PropTypes.array.isRequired,
};

module.exports = ListFilters;
