/**
 * Created by kinfen on 16/8/21.
 */

import React , {Component} from "react";
import _ from "lodash";
import {connect} from 'react-redux';
import PropTypes from 'prop-types';
import { findDOMNode } from 'react-dom';
import {
	Button,
	Popover,
	Icon,
	Tooltip,
} from "antdlib"
const ListToolType = {
	Filter:1,
	Refresh:1 << 1,
	Columns:1 << 2,
}
import {
	setActiveColumns,
} from "../active/actions";

import ListFiltersAdd from './ListFiltersAdd';

export {
	ListToolType,
}


//TODO: prepare to change desion in ant design


class ListToolBar extends Component {
	constructor(props){
		super(props);
		this.state = {
			tools: this.props.tools ? this.props.tools : (ListToolType.Filter | ListToolType.Refresh | ListToolType.Columns),
			checkMap:{},
			showColumns:false,
			showFilter:false,
		}
		this.poplock = false;
	}
	componentDidUpdate(){

	}
	submitColumns(){
		let results = _.filter(this.state.checkMap, {checked:true});
		// results = ["name"].concat(results);
		results = _.map(results, (o) => {
			if (o && o.width){
				return o.name + "|" + o.width
			}
			return o.name;
		});
		this.setState({
			showColumns:false,
		})
		this.props.dispatch(setActiveColumns(results));
		if (this.props.refreshHandler)
		{
			this.props.refreshHandler();
		}
	}

	popupLock(lock){
		this.poplock = lock;
	}

	/**
	 *
	 * @returns {Array}
	 */
	getColumns(){

		// todo: for now columns selections will not be reset after panel fade out without submitted, this will need a fix in the further

		let columnsList = [];
		if (this.props.model)
		{
			let columns = this.props.model.columns;
			let defaultColumnKeys = _.map(this.props.model.expandedDefaultColumns, "path");
			// let selectedColumnKeys = _.map(this.props.columns || defaultColumnKeys, "path");
			let counter = 0;
			columns = _.clone(_.filter(columns, (o) => {

				//header not show
				if (o.type == 'heading')
					return false;
				//textarea not to be show in the list as a column
				return this.props.model.fields[o.path].type != "textarea";
			}));
			
			columnsList = _.map(columns, (obj) => {

				// obj = _.assignIn(obj, {field: typeof obj.field == "object" ? obj.field.path : obj.field})
				const disabled = defaultColumnKeys.indexOf(obj.path) != -1;
				let checked = (this.state.checkMap[obj.path] ? this.state.checkMap[obj.path].checked : null) || disabled;

				let tarObj = _.find(this.props.model.expandedDefaultColumns, {path:obj.path});
				this.state.checkMap = _.assignIn(this.state.checkMap, {
					[obj.path]:{
						name:obj.path,
						checked,
						width:tarObj ? tarObj.width : null,
					},
				});
				
				let node = (
					<p>
						
						<Button
							{...{
								key:counter++,
								disabled,
								type:checked ? 'primary':'default',
								style:{
									width:'100%',
									position: 'relative',
									// alignItems:'center',
									// justifyContent:'space-between',
									// display:'flex',
									// flexDirection:'row',
									/* width: 100%;
									position: relative;
									align-items: center;
									justify-content: space-between;
									display: flex;
									flex-direction: row; */
								},
								onClick:(e) => {
									_.assignIn(this.state.checkMap[obj.path], {
										checked:!checked,
									})
									this.setState({
										checkMap:this.state.checkMap,
									})
								}
							}}
						>
							
							{obj.title}
							{checked && <Icon type='check' style={{
								position:"absolute",
								right:'5',
								lineHeight:'20px',
							}}></Icon>}
						</Button>
					</p>
					);
				return node;
			});
		}
		return columnsList;
	}
	getTools(){
		let self = this;
		let toolsList = [];
		let tools = this.state.tools;
		_.map(ListToolType, (value, key) => {
			if ((tools & value) !== 0){
				switch (key){
					case "Refresh":
						toolsList.push(
							<Tooltip key='Refresh' placement="bottom" title="刷新">
								<Button size="large"
									key={value}
									icon="reload"
									name="refresh"
									title="Refresh"
									onClick={()=>{
										if (this.props.refreshHandler)
										{
											this.props.refreshHandler();
										}
									}}
								/>
							</Tooltip>
							
						);
						break;
					case "Filter":
					{
						const content = (
							<ListFiltersAdd
								dispatch={this.props.dispatch}
								activeFilters={this.props.filtersActive}
								availableFilters={this.props.filtersAvailable}
								popupLock={this.popupLock.bind(this)}
							/>
						)
						toolsList.push(

							<Popover placement="leftTop" content={content}
									trigger="click"
									size="large"
									onVisibleChange={(visible)=>{
										if(this.props.popoverLock) return;
										this.setState({
											showFilter:visible,
										});
									}}
									visible={this.state.showFilter}
							>
								<Tooltip key='Filter' placement="bottom" title="过滤项">
									<Button size="large" icon='filter' />
								</Tooltip>
								
							</Popover>

						);
					}
						break;
					case "Columns":
					{

						const content = (

								<div role="menu">

									<div className="popups">
										<div style={{
											maxHeight:'300px',
											overflow:'auto',
										}}>
											{self.getColumns()}
											
										</div>
										<p className="confirm">
											
												<Button type="primary" size="large" onClick={this.submitColumns.bind(this)}>确认</Button>
											
										</p>
									</div>
								</div>

						);
						toolsList.push(

							<Popover placement="leftTop" content={content}
									 title="请选择显示的列"
									 trigger="click"
									 size="large"
									 onVisibleChange={(visible)=>{
										if(this.props.popoverLock) return;
										this.setState({
											showColumns:visible,
										});
									 }}
									 visible={this.state.showColumns}
							>
								<Tooltip key='Columns' placement="bottom" title="显示列">
									<Button size="large" icon='bars' />
								</Tooltip>
								
							</Popover>

						);
						break;
					}
					default:
					break;
				}
			}
		});
		return toolsList;
	}
	render(){


		return (
			<Button.Group className="pull-right">
				{this.getTools()}
			</Button.Group>
		);
	}
}

ListToolBar.propTypes = {
	filtersActive: PropTypes.array,
	filtersAvailable: PropTypes.array,
}
export default connect((state) => {
	return {
		popoverLock:state.lists.popoverLock,
	}
})(ListToolBar)
