/**
 * Created by kinfen on 2017/5/19.
 */
import React from 'react';
import ReactDOM from 'react-dom';
import _ from "lodash";
import { Fields} from "FieldTypes";
import {
	Form,
	Button,
	Input,
	Modal,
	Alert,
	TreeSelect,
	Spin,
	Row,
	Col,
	Checkbox,
	Card,
	Divider,
	message,
} from 'antdlib';
import path from 'path';
import control from '../../../shared/Control';
import series from 'async/series';
import {
	TreeView
} from '../../treeview'
import ACGroup from '../../ACGroup'
const styleObj = {
	height:300,
	maxHeight:300,
}

class ModuleAppointModal extends React.Component {

	constructor(props){
		super(props);

		var modelObj = props.model;
		this.state = _.assign(super.state, {
			error:null,
			type: "default",
			title: "模块委任",
			moduleData:[],
			actionData:[],
			layout:"horizontal",
			loading:true,
			selectedModuleCode:null,
			indeterminate:false,
			checkAll:false,
			valueMap:{},
		});
	}
	get action(){
		return 'setmodule';
	}
	onModuleSelected(e, nodes){
		if (this.props.roles){
			let role = this.props.roles[0];
			if (role && nodes.length > 0){
				let checkAll = this.state.valueMap[nodes[0].id] ? this.state.valueMap[nodes[0].id].length == this.state.actionData.length : false;
				this.setState({
					selectedModuleCode:nodes[0].id + "@" + 'Module',
					indeterminate: this.state.valueMap[nodes[0].id] ? (this.state.valueMap[nodes[0].id].length > 1 && !checkAll) : false,
					checkAll,
				})
			}
			else {
				this.setState({
					selectedModuleCode:null,
				})
			}

		}
	}
	onChange(e){
		let actions = this.state.valueMap;
		let list = actions[this.state.selectedModuleCode];
		if (!list){
			list = [];
		}
		if (!e.target.checked){
			list = _.pull(list, e.target.value);
		} else if (list.indexOf(e.target.value) == -1) {
			list.push(e.target.value);
		}
		let indeterminate = list.length > 0 && list.length < this.state.actionData.length;
		let checkAll = list.length == this.state.actionData.length;
		actions[this.state.selectedModuleCode] = list;
		this.setState({
			indeterminate,
			checkAll,
			valueMap:_.assign(this.state.valueMap, {
				[this.state.selectedModuleCode]:list
			})
		})



	}
	onCheckAllChange(e){
		let listValue = e.target.checked ? _.map(this.state.actionData, (o) => o.value) : [];
		this.setState({
			indeterminate:false,
			checkAll:e.target.checked,
			valueMap:_.assign(this.state.valueMap, {
				[this.state.selectedModuleCode]:listValue,
			})
		})
	}
	loadAvailActions(cb){
		let url = path.join(KAdm.adminPath, 'api2', "Action", 'list');
		let target = this;
		control.api({
			url,
			data:{

			},
			dataType:"json",
			success:function(data){

				cb(null, data.info.results)
			},
			error:function(xhr, error)
			{

				cb(error)
			}
		});
	}
	loadAvailPermission(cb){
		let url = path.join(KAdm.adminPath, 'api2', "getpermissions");
		let target = this;
		control.api({
			url,
			data:{
				action:"get_permissions",
				role:this.props.roles[0].fields.code,
			},
			dataType:"json"
		}, true, (err, data) => {
			cb(err, data)
		});
	}
	loadAvailModule(cb){
		let url = path.join(KAdm.adminPath, 'api2', "Module", 'tree');
		let target = this;
		control.api({
			url,
			data:{

			},
			dataType:"json",
			success:function(data){

				cb(null, data.list)
			},
			error:function(xhr, error)
			{

				cb(error)
			}
		});
	}
	componentDidMount(){



	}

	renderNodesData(list){
		return _.map(list, (o) => {
			let nodes = o.childs ? this.renderNodesData(o.childs) : null;
			return {
				text:o.name,
				id:o._id,
				nodes,
			}
		})
	}
	submitHandler(e){
		let url = path.join(KAdm.adminPath, "api2", this.action)
		control.api({
			url,
			data:{
				action:"auth_module",
				role:this.props.roles[0].fields.code,
				valueMap:JSON.stringify(this.state.valueMap),
			},
			method:"POST",
			dataType:"json"
		}, true, (err, data) => {
			if (err) {
				message.error(err);
			} else {
				if (data.error){
					message.error(data.error);
				}
				this.hide();
			}
		});
	}
	handleCancel(){
		this.setState({
			show:false,
			error:null,
		})
	}
	errorInfoClose(e){
		delete this.state.error;
	}
	show(){
		this.setState({
			show:true,
			moduleData:[],
			actionData:[],
			loading:true,
			selectedModuleCode:null,
			indeterminate:false,
			checkAll:false,
			valueMap:{},
		})
		let task = {
			modules:this.loadAvailModule.bind(this),
			actions:this.loadAvailActions.bind(this),
			valueMap:this.loadAvailPermission.bind(this),
		}
		series(task,
			(err, results) => {

				if (err) {
					message.error(err);
				}

				let modules = results.modules;
				let actions = results.actions;
				let valueMap = results.valueMap.info;
				modules = this.renderNodesData(modules);
				actions = _.map(actions, (o) => {
					return {label:o.name, value:o.code}
				});

				this.setState({
					moduleData:modules,
					actionData:actions,
					valueMap,
					loading:false,
				})
			});
	}

	hide(){
		this.handleCancel();
		if (this.props.successAndClose){
			this.props.successAndClose();
		}
	}
	renderForm(){
		var modelObj = this.props.model;
		if (!modelObj) return null;


		if (this.props.roles.length == 0){
			return <div>请选择一个对象</div>
		}

		let actionBoxes = _.map(this.state.actionData, (o)=>{
			let actionsValueList = this.state.selectedModuleCode ? this.state.valueMap[this.state.selectedModuleCode] : []
			let checked = this.state.checkAll || (actionsValueList ? actionsValueList.indexOf(o.value) != -1 : false)
			return this.state.selectedModuleCode ?  <Row>
						<Checkbox
							{...{
								key:o.value,
								defaultChecked:false,
								value:o.value,
								checked,
								onChange:this.onChange.bind(this),
							}}
						>{o.label}</Checkbox>
					</Row> : null;
		});

		let contentNode = (
			<Row>
				<Col span={12}>
					<TreeView
						ref="treeView"
						data={this.state.moduleData}
						showIcon={false}
						onSelect={this.onModuleSelected.bind(this)}
					/>
				</Col>
				<Col span={12}>
					<ACGroup visible={this.state.selectedModuleCode}>
						<Checkbox
							indeterminate={this.state.indeterminate}
							onChange={this.onCheckAllChange.bind(this)}
							checked={this.state.checkAll}
						>选择全部</Checkbox>
						<Divider />
						<br/>
						{actionBoxes}
					</ACGroup>


				</Col>
			</Row>

		)

		return (<Form type={this.state.layout } layout={this.state.layout } id="table-create" >
					{this.state.loading ? <Spin size='large'/> :  contentNode}
				</Form>)
	}


	render(){
		var cancelBtn = <Button size="large" onClick={this.handleCancel.bind(this)} key='cancel'>取消</Button>;
		var okBtn = <Button type="primary" size="large" loading={this.state.loading} onClick={this.submitHandler.bind(this)} key='create'>确认</Button>

		var formNode = this.renderForm()

		var alertNode = this.state.error ? <Alert
			message="错误"
			description={this.state.error}
			type="error"
			showIcon
			closable
			onClose={this.errorInfoClose.bind(this)}
		/> : null;

		return (
			<Modal
				visible={this.state.show}
				title={this.state.title}
				onCancel={this.handleCancel.bind(this)}
				footer={[okBtn, cancelBtn]}
				style={styleObj}
			>
				{alertNode}
				{formNode}
			</Modal>
		)
	}

}

export default  ModuleAppointModal;
