/**
 * Created by kinfen on 2017/5/19.
 */
import React from 'react';
import ReactDOM from 'react-dom';
import _ from "lodash";
import { Fields} from "FieldTypes";

import {
	Form,
	Button,
	Input,
	Modal,
	Alert,
	TreeSelect,
	Spin,
	message,
} from 'antdlib';
import path from 'path';
import control from '../../../shared/Control';
import series from 'async/series';
const TreeNode = TreeSelect.TreeNode;


class RoleAppointModal extends React.Component {

	constructor(props){
		super(props);

		var modelObj = props.model;

		this.state = _.assign(super.state, {
			created:false,
			error:null,
			type: "default",
			title: "角色委任",

			layout:"horizontal",
			value:[],
			data:[],
			loading:true,
		});
	}
	onChange(value){
		this.setState({ value });
	}
	loadCurrentRoles(cb){
		if (this.props.users && this.props.users.length == 1){
			let ids = _.map(this.props.users, (o) => {
				return o.id;
			})
			let itemId = ids[0];
			let list = KAdm.model["UserRole"];
			let url = path.join(KAdm.adminPath, 'api2', "UserRole", "list");
			control.api({
				url,
				data:{
					p:1,
					populate:'role',
					search:JSON.stringify({
						name:itemId
					}),
				},
				dataType:"json",
			}, false, (err, data) => {
				if (!data.error){
					if (data.info.results.length > 0){
						cb(null, data.info.results[0])
						return;
					}
				}
				cb(err, [])
			})
		}
		else {
			cb(null, [])
		}

	}
	loadAllRoles(cb){
		let url = path.join(KAdm.adminPath, 'api2', "Role", 'tree');
		let target = this;
		control.api({
			url,
			data:{

			},
			dataType:"json",
			success:function(data){
				if (data.status == 1){
					target.setState({
						data:data.list,
						loading:false,
					})
				}
				cb(null, data.list)
			},
			error:function(xhr, error)
			{
				target.setState({
					loading:false,
				})
				cb(error)
			}
		}, false, (err, data) => {
			if (!data.error){
				target.setState({
					data:data.list,
					loading:false,
				})
				cb(null, data.list)
			} else {
				target.setState({
					loading:false,
				})
				cb(error)
			}

		});
	}
	componentDidMount(){



	}

	renderNodesData(list){

		return _.map(list, (o) => {
			let childs = o.childs ? this.renderNodesData(o.childs) : null;
			return {
				label:o.name,
				value:o._id,
				children:childs,

			}
		})
	}
	submitHandler(e){
		let value = _.map(this.state.value, (o) => o.value);
		let users = _.map(this.props.users, (o) => o.id);
		let url = path.join(KAdm.adminPath,  'api2', "authroles", "UserRole");
		control.api({
			url,
			data:{
				whereCase:JSON.stringify(users),
				role:JSON.stringify(value),
				action:'updateAndCreateWithNames',
				method:"POST",
			},
			dataType:"json",

		}, true, (err, data) => {
			if (!data.error && data.list.length > 0){
				this.hide();
			}
			if (err){
				message.error(error);
			}
		})

	}
	handleCancel(){
		this.setState({
			show:false,
			error:null,
		})
	}
	errorInfoClose(e){
		delete this.state.error;
	}
	show(){
		this.setState({
			show:true,
		})
		series([
				this.loadCurrentRoles.bind(this),
				this.loadAllRoles.bind(this),
			],
			(err, results) => {
				let rolesData = results[0];
				let rolesList = [];

				rolesList = _.map(rolesData.role, (o) => {
					return {label:o.name, value:o._id}
				});

				this.setState({
					value:rolesList,
					data:results[1],
				})
			});
	}

	hide(){
		this.handleCancel();
		if (this.props.successAndClose){
			this.props.successAndClose();
		}
	}
	renderForm(){
		var modelObj = this.props.model;
		if (!modelObj) return null;
		var initFields = modelObj.initialFields;
		var fieldList = [];
		let user;
		var treeNodes = this.renderNodesData(this.state.data);


		if (this.props.users.length == 0){
			return <div>请选择一个对象</div>
		}
		else {
			user = this.props.users[0];
		}
		let selectNode =  <TreeSelect
			showSearch
			value={this.state.value}
			dropdownStyle={{ maxHeight: 400, overflow: 'auto' }}
			placeholder="请选择角色"
			allowClear
			multiple
			treeDefaultExpandAll
			name="roles"
			ref="roles"
			labelInValue
			onChange={this.onChange.bind(this)}
			treeData={treeNodes}
		/>
		return <Form type={this.state.layout } layout={this.state.layout } id="table-create" >
			{this.state.loading ? <Spin size='large'/> :  selectNode}
		</Form>
	}


	render(){
		var cancelBtn = <Button size="large" onClick={this.handleCancel.bind(this)} key='cancel'>取消</Button>;
		var okBtn = <Button type="primary" size="large" loading={this.state.loading} onClick={this.submitHandler.bind(this)} key='create'>确认</Button>

		var formNode = this.renderForm()

		var alertNode = this.state.error ? <Alert
			message="错误"
			description={this.state.error}
			type="error"
			showIcon
			closable
			onClose={this.errorInfoClose.bind(this)}
		/> : null;

		return (
			<Modal
				visible={this.state.show}
				title={this.state.title}
				onCancel={this.handleCancel.bind(this)}
				footer={[okBtn, cancelBtn]}
			>
				{alertNode}
				{formNode}
			</Modal>
		)
	}

}
export default  RoleAppointModal;
