/**
 * Created by kinfen on 16/7/26.
 */
import _ from 'lodash';
import List from '../../../utils/List';
import {
	LIST_SELECT_MODEL,
	LIST_COLUMNS,
	LIST_FILTERS,
	LIST_PAGE,
	LIST_SORT,
	LIST_CONTENT_LOADING,
	LIST_CONTENT_LOAD,
	LIST_CONTENT_ERROR,
	LIST_CLEAR_CONTENT,
	LIST_POPOVER_LOCK_CHANGE,
} from './actions'
const initialState = {
	model:{},
	search:"",
	list:null,
	currentModel:null,
	filters:[],
	sort:null,
	page:{size:10, index:1},
	columns:null,
	loading:false,
	totalPages:1,
	data:[],
	catid:null,
	popoverLock:false,
};

const initialLists = KAdm.lists;
KAdm.model = {}
for (const name in initialLists) {
	if ({}.hasOwnProperty.call(initialLists, name)) {
		const currentList = initialLists[name];
		initialState.model[currentList.key] = new List(currentList);
		KAdm.model[currentList.key] = initialState.model[currentList.key]
	}
}

function list (state = initialState, action) {
	switch (action.type) {
		case LIST_SELECT_MODEL:
			return _.assign({}, state, {
				currentModel: action.currentModel,
				menuActions: action.menuActions,
			});
		case LIST_CLEAR_CONTENT:
			return _.assign({}, state, {
				totalPages:0,
				total:0,
				data:[]
			});
		case LIST_COLUMNS:
			return _.assign({}, state, {
				columns: action.columns,
			});
		case LIST_FILTERS:
			return _.assign({}, state, {
				filters: action.filters,
			});
		case LIST_PAGE:
			return _.assign({}, state, {
				page: action.page,
			});
		case LIST_SORT:
			return _.assign({}, state, {
				sort: action.sort,
			});
		case LIST_CONTENT_LOADING:
			return _.assign({}, state, {
				loading: action.loading,
			});
		case LIST_CONTENT_LOAD:
			return _.assign({}, state, {
				data:action.data,
				totalPages:action.totalPages,
				total:action.total,
			});

		case LIST_CONTENT_ERROR:
			return _.assign({}, state, {
				categoryLoading:false,
			});
		case LIST_POPOVER_LOCK_CHANGE:
			return _.assign({}, state, {
				popoverLock:action.popoverLock,
			});
		default:
			return state;
	}
}
export default list;
