import React from 'react';
import _ from "lodash";
import { connect } from 'react-redux';
// import TreeNode from './TreeNode';
import {
	Tree,
} from 'antdlib';
const TreeNode = Tree.TreeNode;
var TreeView = React.createClass({

	treeNodes:[],
	propTypes: {
		levels: React.PropTypes.number,

		expandIcon: React.PropTypes.string,
		collapseIcon: React.PropTypes.string,
		emptyIcon: React.PropTypes.string,
		nodeIcon: React.PropTypes.string,

		color: React.PropTypes.string,
		backColor: React.PropTypes.string,
		borderColor: React.PropTypes.string,
		onhoverColor: React.PropTypes.string,
		selectedColor: React.PropTypes.string,
		selectedBackColor: React.PropTypes.string,

		enableLinks: React.PropTypes.bool,
		highlightSelected: React.PropTypes.bool,
		showBorder: React.PropTypes.bool,
		showTags: React.PropTypes.bool,
		showCheckbox:React.PropTypes.bool,

		nodes: React.PropTypes.arrayOf(React.PropTypes.number),
	},

	getDefaultProps: function () {
		return {
			levels: 2,
			onSelect:null,
			expandIcon: 'glyphicon glyphicon-plus',
			collapseIcon: 'glyphicon glyphicon-minus',
			emptyIcon: 'glyphicon',
			nodeIcon: 'glyphicon glyphicon-stop',

			color: undefined,
			backColor: undefined,
			borderColor: undefined,
			onhoverColor: '#F5F5F5', // TODO Not implemented yet, investigate radium.js 'A toolchain for React component styling'
			selectedColor: '#FFFFFF',
			selectedBackColor: '#428bca',
			enableLinks: false,
			highlightSelected: true,
			showBorder: true,
			showTags: false,
			showCheckbox:false,
			nodes:[]
		}
	},
	getInitialState: function() {
		return {
			selectedNodeId:-1,
			selectedNode:null,
			checkedNodes:[],
			halfCheckedNodes:[],
		};
	},
	componentWillReceiveProps(nextProps){
		if (nextProps.data != this.props.data){
			this.state = this.getInitialState();
		}
	},
	componentDidMount:function(){
	},
	findNodeDeeply(nodes, cb){
		let self = this;
		var innerItem;
		var item = _.find(nodes, function (obj){
			var result = cb(obj);
			if (result) return true;
			else {
				if (obj.nodes && obj.nodes.length > 0)
				{
					innerItem = self.findNodeDeeply(obj.nodes, cb);
					return innerItem != undefined;
				}
			}

		});
		return innerItem || item;
	},
	eachParentNode(rootNode, leaveNode, cb){
		var parentNode = leaveNode;
		while(parentNode){
			parentNode = this.findNodeDeeply(rootNode, (obj) => {
				return obj.nodes && obj.nodes.indexOf(parentNode) != -1;
			});
			if (parentNode)
			{
				cb(parentNode);
			}
		}
	},
	eachNodeDeeply(nodes, cb){
		let self = this;
		_.each(nodes, function (obj){
			cb(obj);
			if (obj.nodes && obj.nodes.length > 0)
			{
				self.eachNodeDeeply(obj.nodes, cb);
			}
		});
	},
	setNodeId: function(node) {

		if (!node.nodes) return;
		var _this = this;
		node.nodes.forEach(function checkStates(node) {
			node.nodeId = _this.props.nodes.length;
			_this.props.nodes.push(node.nodeId);
			_this.setNodeId(node);
		});
	},
	getSelectedNode(){
		return this.state.selectedNode;
	},
	getCheckedNodes(){
		return this.state.checkedNodes;
	},
	onNodeSelected(selectedKeys, e){
		const nodes = _.map(e.selectedNodes, (o) => o.props.node);
		if (selectedKeys)
		{
			this.props.onSelect(e, nodes);
		}
		this.setState({
			selectedNodeId: selectedKeys[0],
			selectedNode: nodes,
		});
	},
	onNodeChecked(checkedKeys, e){

		// const nodes = _.map(e.checkedNodes, (o) => o.props.node);
		// this.refs.tree.checkedKeys = [e.node.props.node.id];
		const newCheckNode = e.node.props.node;
		const childsNodes = newCheckNode.nodes;
		var list = [];
		const currentCheck = !e.node.props.checked;
		//check if current node whether need to switch
		if (!currentCheck){
			newCheckNode.checked = false;

		}
		else {
			newCheckNode.checked = true;
			newCheckNode.halfChecked = false;
		}

		//full check or uncheck subnodes depends on current node's condition
		this.eachNodeDeeply (childsNodes, (node) => {

			const index = list.indexOf(node);
			node.checked = index == -1 && currentCheck ? true : false;
			node.halfChecked = node.checked ? false : node.halfChecked;
		});

		//find parent node to uncheck while do uncheck leaf node
		if (!currentCheck){
			this.eachParentNode(this.props.data, newCheckNode, (parent) => {
				parent.checked = false;
			});
		}

		//update all parent node check state
		//find parent node to uncheck while do uncheck leaf node
		var half = [];

		this.eachParentNode(this.props.data, newCheckNode, (parent) => {
			var checkCounts = 0;
			_.each(parent.nodes, (o) => {
				checkCounts += o.checked ? 1 : 0;
			})
			if (checkCounts != parent.nodes.length){
				parent.halfChecked = true;
				parent.checked = false;
			}
			if (checkCounts == 0){
				parent.halfChecked = false;
			}
		});

		this.eachNodeDeeply(this.props.data, (node) => {
			if (node.checked){
				list.push(node);
			} else if (node.halfChecked){
				half.push(node);
			}
		})

		this.setState({
			checkedNodes:list,
			halfCheckedNodes:half,
		});
	},

	findTreeNodeNodes:function(nodes, level, idIter){

		var _this = this;
		var list = [];

		_.each(nodes,function (node) {
			idIter++;
			var key = "treenode_" + idIter;

			node.nodeId = idIter;
			var nodeExpended;



			var sublist = _this.findTreeNodeNodes(node.nodes, level + 1, idIter);
			var treeNode = (
				<TreeNode
					title={node.text}
					key={node.id}
					node={node}
					isLeaf={sublist.length == 0 ? true : false}
				>
					{sublist}
				</TreeNode>
			)



			list.push(treeNode);



		});

		return list;
	},
	render: function() {

		var data = this.state.data || this.props.data;
		var children = [];
		if (data) {
			children = this.findTreeNodeNodes(data, 1, 0);
		}
		this.treeNodes = children;

		const checked = _.map(this.state.checkedNodes, (o) => (
			o.id
		));
		const halfChecked = _.map(this.state.halfCheckedNodes, (o) => (
			o.id
		));

		return (
			<Tree
				{...{
					ref:"tree",
					checkedKeys:{
						checked,
						halfChecked,
					},
					checkable:this.props.showCheckbox,
					autoExpandParent:true,
					showLine:true,
					checkStrictly:true,
					showIcon:this.props.showIcon,
					onSelect:this.onNodeSelected.bind(this),
					onCheck:this.onNodeChecked.bind(this),
				}}
			>
				{children}
			</Tree>
		);
	}
});

export {
	TreeView,
	TreeNode
}


