import _ from 'lodash';
import {
	TREEVIEW_NODE_EXPAND,
	TREEVIEW_NODE_SELECT,
	TREEVIEW_SHOWCHECKBOX,
	TREEVIEW_NODE_CHECK,
} from './actions'
const initialState = {
	treeNodes:{},
	showCheckbox:false,
};

function treeview (state = initialState, action) {
	switch (action.type) {
		case TREEVIEW_NODE_EXPAND:
			var key = "treenode" + action.nodeId;
			state.treeNodes[key] = _.assign({}, state.treeNodes[key], action.expanded);
			return _.assign({}, state, {
				treeNodes:state.treeNodes
			});
		case TREEVIEW_NODE_SELECT:
			var key = "treenode" + action.nodeId;
			return _.assign({}, state, {
				selectedNodeId:state.selectedNodeId == action.nodeId ? -1 : action.nodeId,
			});
		case TREEVIEW_SHOWCHECKBOX:
			
			return _.assign({}, state, {
				showCheckbox:state.showCheckbox
			});
		case TREEVIEW_NODE_CHECK:
			var key = "treenode" + action.nodeId;
			state.treeNodes[key] = _.assign({}, state.treeNodes[key], action.checked);
			return _.assign({}, state, {
				treeNodes:state.treeNodes
			});
		default:
			return state;
	}
}

export default treeview;
