/**
 * Created by kinfen on 16/7/26.
 */


import React from 'react';
import ReactDOM from 'react-dom';
import { Router, Route, browserHistory, IndexRoute, Redirect} from 'react-router';
import { Provider } from 'react-redux';
import { syncHistoryWithStore } from 'react-router-redux';
//
import App from './App';
//import Home from './screens/home';
import ItemView from './screens/item';
import reduxManager from "kadm-redux-mng";
import List from './screens/lists';

import InnerApp from './screens/innerapp';
import InnerAppList from './screens/innerapp/list';
import InnreAppItem from './screens/innerapp/item';
//import About from './screens/about';
//
var store = reduxManager.getStore();

// Sync the browser history to the Redux store
const history = syncHistoryWithStore(browserHistory, store);

console.log('run run run');
ReactDOM.render(
	<Provider store={store}>
		<Router history={history}>
			<Route path="/admin" component={App}>
				<Route path="item/:model/:id" component={ItemView}/>
				<Route path="list/:model" component={List}/>
				{reduxManager.getRoutes()}
				<Route path="innerapp/:app/:appid" component={InnerApp}>
					<Route path="list/:model" component={InnerAppList} />
					<Route path="item/:model/:id" component={InnreAppItem} />
				</Route>
				<Redirect from=":model/:id" to="item/:model/:id" />
			</Route>
		</Router>
	</Provider>,
	document.getElementById('admin-root')
);

export {
	store,
	history
}
