/**
 * Created by kinfen on 16/2/1.
 */


import React from 'react';
import _ from 'lodash';
import { connect } from 'react-redux';

import {
    components,
    actions,
	control,
} from 'kadm-component';

import reduxManager from "kadm-redux-mng";
var store = reduxManager.getStore();
import path from 'path';

var {
	Modal,
	LaddaBtn
} = components.utilsForReactDom;
import { Link } from 'react-router';
import {
	Card,
	Button,
	Menu,
	Spin,
	Icon,
	Layout,
} from 'antdlib';

var TreeView = components.treeview;
var Component = components.KComponent;
var {
	Sider,
	Header,
	Content,
} = Layout;
import {
	selecteModule,
	initListFilters
} from '../actions';


var {
	setFilter
} = actions.active;
var {
	selectModel
} = actions.lists;
class SiderMenu extends Component{
	constructor(props){
		super(props)
		this.selectedNode = null;
		this.showCreateForm = false;

	}
	state = {
		collapsed: false,
	}
	
	componentWillReceiveProps(nextProps){
		// if (nextProps.module != this.props.module){
		// 	this.refreshCategory(nextProps.module);
		// }
	}
	componentDidMount () {
		// $(this.refs.createForm).hide();
		// this.refreshCategory(this.props.module);
		// store.dispatch(treeNodeTitle("栏目组"));
	}
	
	onNodeSelected(e, nodes){

		if (this.props.editMode){

		}
		else {
			this.props.onNodeSelected(e, nodes);
		}
		//var ids = $('.box-body .tree-group').treeview("getExpanded");
	}

	renderHeader(){
		let toolsNormal = (
			<Button icon="edit"  size="large" shape="circle">
			</Button>
		);
		return (
				<div style={{
					clearFix:"both",
				}}>
					<h3 className="box-title">{this.props.title}</h3>
					<div className="box-tools">
						{toolsNormal}
					</div>
				</div>
		);
	}
	// renderCreateForm(){

	// 	return (
	// 		<form component="form" type="horizontal"  id="table-create" ref="createForm" onSubmit={this.submitHandler.bind(this)}>
	// 			<div className="form-group">
	// 				<div className="input-group" >
	// 					<input name="name"  type="text" className="form-control" placeholder="名称"/>
	// 					<input name="module"  type="hidden" value={this.props.module}/>
	// 					<div className="input-group-btn">
	// 						<LaddaBtn submit ref="submitBtn" direction="left" type="primary" >创建</LaddaBtn>
	// 					</div>
	// 				</div>
	// 			</div>
	// 		</form>
	// 	);
	// }

	renderTreeMenu(modules, level){
		var list = [];
		if (modules.length > 0)
		{
			var self = this;
			_.each(modules, (element, index) => {
				let subNods;
				let rightItem;
				if (element.childs && element.childs.length > 0)
				{
					subNods = (
						<Menu.SubMenu key={element._id} title={<span><Icon type={element.icon} /><span>{element.name}</span></span>} >
							{self.renderTreeMenu(element.childs, level + 1)}
						</Menu.SubMenu>);
					list.push(subNods);

				}
				else {
					var link = path.join('/', KAdm.adminPath, 'innerapp', this.props.params.app, this.props.params.appid, element.link ? element.link : "#")
				
					list.push(
						<Menu.Item key={element._id}>

							<Link to={link} onClick={() => {
								store.dispatch(selecteModule(element));
								// store.dispatch(selectModel(this.props.params.model));
								store.dispatch(initListFilters( 'innerApp', this.props.params.appid));
							}}>
								<Icon type={element.icon} />
								<span>{element.name}</span>
							</Link>
						</Menu.Item>
					);
				}

			});
		}
		return list;
	}

	render(){

		var treeView = this.props.treeNodeLoading ? null : <TreeView
			ref="treeView"
		 	data={this.props.treeData}
			showIcon={false}
		 	showCheckbox={this.props.editMode}
		 	onSelect={this.onNodeSelected.bind(this)}
		 />;

		return (
			<Sider style={{ background: '#fff' }}
				collapsed={this.state.collapsed}
			>
				<Layout>
					<Header style={{
						background: '#fff',
						display:'flex',
						justifyContent:'flex-end',
						alignItems:'center', 
						padding:'0 15px',
					}}>
						<Button size='small' 
							style={{
								border:'none',
							}} 
							icon={this.state.collapsed ? 'menu-unfold' : 'menu-fold'}
							onClick={() => {
								this.setState({
									collapsed:!this.state.collapsed
								})
							}}
						>

						</Button>
					</Header>
					<Content>
						{!this.props.modules && 
						<div style={{
							textAlign:'center',
						}}>
							<Spin />
						</div>}
						{this.props.modules && 
						<Menu
							defaultSelectedKeys={['0']}
							mode="inline"
							inlineCollapsed={this.state.collapsed}
						>
							{this.renderTreeMenu(this.props.modules, 0)}
						</Menu>}
					</Content>
				</Layout>

			</Sider>
		);
	}
	componentDidUpdate(preProps, preState){
		//this.updateTrees();
	}

};

export {
	SiderMenu
}
export default connect((state) => {
	return {
		treeNodeLoading:state.listca.treeNodeLoading,
		editMode:state.listca.editMode,
		treeData:state.listca.treeData,
		title:state.listca.title,
	}
})(SiderMenu)

//KAdm.mainCategory = ReactDOM.render(
//	<Category navs={KAdm.navs} initCategory={KAdm.category} onNodeSelected={KAdm.control.category.onNodeSelected}/>, $("#category")[0]
//);
