
import React from 'react';

import { connect } from 'react-redux';

import {components, actions} from 'kadm-component';
import reduxManager from "kadm-redux-mng";
var ContentHeader = components.ContentHeader;
import {
	Layout,
} from 'antdlib';
const { Header,  Content } = Layout;
var {
	selectModel,
	selectList,
	clearContent,
} = actions.lists;
var {ListView, KComponent} = components;
var store = reduxManager.getStore();


class List extends KComponent{
	constructor(props){
		super(props);

	}
	componentWillReceiveProps(nextProps){
		if (nextProps.params.model != this.props.params.model){
			store.dispatch(clearContent());
			store.dispatch(selectModel(nextProps.params.model));
		}
	}
	componentWillMount(){
		store.dispatch(selectModel(this.props.params.model));
	}
	
	render(){
		return (

			<Layout>
				<Header className="content-header">
					<ContentHeader/>
				</Header>
				<Content className="page-content" style={{ margin: '0 16px', padding: 24, minHeight: 280 }}>
					<section className="content">
						<div className="row">
							<ListView
								ref="cateContent"
								apiPath="api2"
								title={this.props.selectedModule ? this.props.selectedModule.name : ""}
								columns={this.props.columns}
								store={store}
							/>
						</div>
					</section>
				</Content>
			</Layout>
		)
	}
};

export {
	List,
	ListView,
}
export default connect((state) => {
	return {
		loading:state.lists.loading,
		currentModel:state.lists.currentModel,
		columns:state.active.columns,
		selectedModule:state.app.selectedModule,
	}
})(List)
