/**
 * Created by kinfen on 2017/8/4.
 */


import React from 'react';
import ReactDOM from 'react-dom';
import Component from '../components/KComponent';
import Layout from 'antd/lib/layout';
import Menu from 'antd/lib/menu';
import Row from 'antd/lib/row';
import Col from 'antd/lib/col';
const SubMenu = Menu.SubMenu;
import Icon from 'antd/lib/icon';
const { Header, Sider, Content, Footer } = Layout;
import FooterContent from '../components/Footer';
import ContentHeader from '../components/ContentHeader';
class Test extends Component{
	state = {
		collapsed: false,
	};
	toggle = () => {
		this.setState({
			collapsed: !this.state.collapsed,
		});
	}
	render(){

		const LogoB = <span><strong>K</strong></span>;
		const LogoS = <span><strong>KA</strong>dmin</span>;

		return (
			<Layout>
				<Sider
					trigger={null}
					collapsible
					collapsed={this.state.collapsed}
				>

					<Header className="logo slider-header" >
						{
							this.state.collapsed ? LogoB : LogoS
						}
					</Header>
					<Menu theme="dark" defaultSelectedKeys={['1']} mode="inline">
						<Menu.Item key="1">
							<Icon type="pie-chart" />
							<span>Option 1</span>
						</Menu.Item>
						<Menu.Item key="2">
							<Icon type="desktop" />
							<span>Option 2</span>
						</Menu.Item>
						<SubMenu
							key="sub1"
							title={<span><Icon type="user" /><span>User</span></span>}
						>
							<Menu.Item key="3">Tom</Menu.Item>
							<Menu.Item key="4">Bill</Menu.Item>
							<Menu.Item key="5">Alex</Menu.Item>
						</SubMenu>
						<SubMenu
							key="sub2"
							title={<span><Icon type="team" /><span>Team</span></span>}
						>
							<Menu.Item key="6">Team 1</Menu.Item>
							<Menu.Item key="8">Team 2</Menu.Item>
						</SubMenu>
						<Menu.Item key="8">
							<Icon type="file" />
							<span>File</span>
						</Menu.Item>
					</Menu>


				</Sider>
				<Layout>
					<Header theme="dark" className="main-header">
						<Row >
							<Col span={4} >
								<Icon
									className="trigger"
									size="large"
									type={this.state.collapsed ? 'menu-unfold' : 'menu-fold'}
									onClick={this.toggle}
								/>
							</Col>
							<Col span={20} >
								<Menu
									theme="dark"
									mode="horizontal"
									defaultSelectedKeys={['2']}
									style={{ lineHeight: '64px' }}
								>
									<Menu.Item key="1">nav 1</Menu.Item>
									<Menu.Item key="2">nav 2</Menu.Item>
									<Menu.Item key="3">nav 3</Menu.Item>
								</Menu>
							</Col>
						</Row>


					</Header>
					<Content>
						<Layout>
							<Header className="content-header">
								<ContentHeader/>
							</Header>
							<Content style={{ margin: '0 16px', padding: 24, background: '#fff', minHeight: 280 }}>

							</Content>
						</Layout>
					</Content>
					<Footer>
						<FooterContent/>
					</Footer>
				</Layout>
			</Layout>
		)
	}
}


ReactDOM.render(
	<Test/>,
	document.getElementById('admin-root')
);
