/**
 * Created by kinfen on 16/1/21.
 */

var browserify = require('./middleware/browserify');
var express = require('express');
var less = require('less-middleware');
var path = require('path');
var str = require('string-to-stream');
var kadm = require('../../../');
var keystone = kadm.getAdminPlus();
var keystoneFields = require('../../../fields/fields');

module.exports = exports = function () {
	var router = express.Router();
	/* Prepare browserify bundles */
	if (process.env.NODE_ENV === 'debug') {
		var elementalPath = path.join(path.dirname(require.resolve('elemental')), '..');
		var reactSelectPath = path.join(path.dirname(require.resolve('react-select')), '..');
		var keystonePath = kadm.getKeystonePath();
		var antdPath = path.join(path.dirname(require.resolve('antd')), '..');
		var lessOptions = {
			render: {
				modifyVars: {
					elementalPath: JSON.stringify(elementalPath),
					reactSelectPath: JSON.stringify(reactSelectPath),
					adminPath:JSON.stringify(keystone.get('admin path')),
					keystonePath: JSON.stringify(keystonePath),
					antdPath:JSON.stringify(antdPath),
				}
			},
			debug:true
		};
		router.use('/style', less(path.resolve(__dirname , '../public/style'), lessOptions));
	}

    //
	/* Configure router */

	router.use(express.static(path.resolve(__dirname + '../../public')));

	return router;
};
