/**
 * Created by kinfen on 16/2/2.
 */

var Base = require('../api/global/Base');
var kadm = require('../../../');
var _ = require('lodash');
var keystone = kadm.getAdminPlus();
var rbacManager = require('../../../core/acl/RBACManager');

module.exports = function(req, res) {

	var search = req.query.search;
	var fields = req.query.fields ? req.query.fields.split(',') : null;
	var page = req.query.p || 1;
	var sortTag = req.query.sort || req.list.defaultSort;
	var pageSize = req.query.ps || 10;
	var searchTag  = {};
	var populate = req.query.populate;
	if (search)
		_.extend(searchTag, JSON.parse(search));
	//console.log(req.list.getOptions());
	if (!fields)
	{
		fields = _.map(req.list.getOptions().uiElements, function(value, index){
			return value.field;fields.push("name");
		});
		fields.push("_id");
		fields.push("navs");
	}
	var db = req.list.paginate({
		page: page,
		perPage: pageSize,
		filters:searchTag
	});
	rbacManager.dbFilterWithIdAuth(req, db, req.list.key, (err, newDb) => {
		//it may now include createdBy in filters
		if (err) return Base.error(res, err);
		newDb = newDb.where(searchTag)
		if (populate){
			newDb = newDb.populate(populate);
		}
		if (sortTag)
		{
			newDb.sort(sortTag);
		}
		newDb.exec(function(err, items) {
			if (err) return Base.error(res, 'database error', err);

			Base.json(res, {
				status:1,
				info:items
			});
		});

	})


};
