/**
 * Created by kinfen on 2017/11/7.
 */


/**
 * Created by kinfen on 16/3/5.
 */
var Base = require('./global/Base');
var kadm = require('../../../');
var _ = require('lodash');
var keystone = kadm.getAdminPlus();
var adapter = require("../../../lib/storage/adapters/upload");
var path = require('path');


module.exports = function(req, res) {

	if (req.method === "GET") {
		return Base.error(res, "Error", new Error('上传不支持GET方法'), 'not support get');
	}
	if (!keystone.security.csrf.validate(req)) {
		return Base.error(res, "Error", new Error('csrf检验错误'), 'csrf检验错误');
	}

	let {
		uploadPath,
		schema,
	} = req.body;

	schema = schema ? JSON.parse(schema) : {}
	let schemaObj = {};
	_.forEach(schema, (o) => {
		schemaObj[o] = true;
	})
	let storage = new keystone.Storage({
			adapter: adapter,
			fs: {
				path: path.join(keystone.get('site-statics'), 'uploads', uploadPath),
				publicPath: path.join('/uploads', uploadPath, '/'),
			},
			schema:schemaObj,
	});

	if (req.files && req.files.file){
		storage.uploadFile(req.files.file, function (err, result) {
			if (err){
				return Base.error(res, "Error", err, err.message);
			}
			Base.json(res, {
				status:1,
				info:{
					result:result
				}
			});
		});
	}
	else {
		return Base.error(res, "Error", new Error('找不到上传文件'), '找不到上传文件');
	}
};




