/**
 * Created by kinfen on 16/1/26.
 */
var kadm = require('../../../');
var keystone = kadm.getAdminPlus();
var rbacManager = require('../../../core/acl/RBACManager');
var _ = require('lodash');
var path = require('path');
var express = require('express');


exports = module.exports = function(app) {
	var authRouter = require("./authRouter")();
	var serverRoutes = require("./serverRoutes")();
	var jsRoutes = require("../../client/prebuild/buildClientJs")();
	var staticRoutes = require("./staticRoutes")();
	if (keystone.get("site-statics")){
		// console.log(keystone.get("site-statics"));
		app.use(express.static(keystone.get("site-statics")));
	}
	rbacManager.bindRouterParams(serverRoutes);
	app.use ("/" + kadm.get("kadmPath"), jsRoutes);
	app.use ("/" + kadm.get("kadmPath"), staticRoutes);
	app.use ("/" + kadm.get("kadmPath"), authRouter);
	app.use ("/" + kadm.get("kadmPath"), rbacManager.bindPermissionToRequest.bind(rbacManager), serverRoutes);
	if (kadm.get("routes"))
	{
		app.use("/", kadm.get("routes")());
	}

	//finally ready for keystone api service
	let keystonePath = kadm.getKeystoneRelativePath(__dirname);

	var keystoneServerRoutes = require(keystonePath + '/keystone/admin/server').createDynamicRouter(keystone)
	var keystoneStaticRoutes = require(keystonePath + '/keystone/admin/server').createStaticRouter(keystone)
	var blockRouters = require('./keystoneBlockRoutes')();

	//import all routes of plugins
	let pluginList = keystone.get('plugins');
	_.forEach(pluginList, (o) => {
		// let queryPath = path.join('/', o.getName());
		app.use(o.getRoute(rbacManager));
	})

	rbacManager.bindRouterParams(blockRouters);
	app.use('/' + keystone.get('admin path'), keystoneStaticRoutes);
	app.use('/' + keystone.get('admin path'), rbacManager.bindPermissionToRequest.bind(rbacManager), blockRouters);
	app.use('/' + keystone.get('admin path'), rbacManager.bindPermissionToRequest.bind(rbacManager), keystoneServerRoutes);

}
