/**
 * Created by kinfen on 16/1/19.
 * 处理所有后台路由
 */
var	express = require('express');
var kadm = require('../../../index');
var keystone = kadm.getAdminPlus();
var path = require('path');
var _ = require('lodash');
var Base = require('../api/global/Base');
var rbacManager = require('../../../core/acl/RBACManager');


exports = module.exports = function() {
	var router = express.Router();

	router.get('/api/:list', rbacManager.routerCheckWithParamName('read', 'list'));
	router.post('/api/:list/create', rbacManager.routerCheckWithParamName('add', 'list'));
	router.post('/api/:list/update', rbacManager.routerCheckWithParamName('add', 'list'));
	router.post('/api/:list/delete', rbacManager.routerCheckWithParamName('delete', 'list'));

	// items
	router.get('/api/:list/:id', rbacManager.routerCheckWithParamName('read', ['id', 'list']));
	router.post('/api/:list/:id', rbacManager.routerCheckWithParamName('add', ['id', 'list']));
	router.post('/api/:list/:id/delete', rbacManager.routerCheckWithParamName('delete', ['id', 'list']));
	router.post('/api/:list/:id/sortOrder/:sortOrder/:newOrder', rbacManager.routerCheckWithParamName('read', ['id', 'list']));
	return router;
};
