/**
 * Created by kinfen on 16/8/23.
 */

var ejs = require('ejs');
var path = require('path');
var kadm = require('../../../../');
var templatePath = path.resolve(__dirname, '../../templates/views/signin.ejs');

module.exports = function SigninRoute (keystone) {
	return function (req, res) {
		var locals = {
			adminCore: '/' + keystone.get('admin path'),
			adminPath: '/' + kadm.get("kadmPath"),
			brand: keystone.get('brand'),
			csrf: { header: {} },
			from: req.query.from,
			logo: keystone.get('signin logo'),
			redirect: keystone.get('signin redirect'),
			user: req.user,
			userCanAccessKeystone: true,
		};
		locals.csrf.header[keystone.security.csrf.CSRF_HEADER_KEY] = keystone.security.csrf.getToken(req, res);
		ejs.renderFile(templatePath, locals, {}, function (err, str) {
			if (err) {
				console.error('Could not render Admin UI Signin Template:', err);
				return res.status(500).send(keystone.wrapHTMLError('Error Rendering Signin', err.message));
			}
			res.send(str);
		});
	};
};
