/**
 * Created by kinfen on 16/8/23.
 */
var kadm = require('../../../../');
var keystone = kadm.getAdminPlus();
var session = keystone.session;

module.exports = function SignoutRoute (keystone) {
	return function (req, res) {
		session.signout(req, res, function () {
			// After logging out, the user will be redirected to /signin?signedout
			// It shows a bar on top of the sign in panel saying "You have been signed out".
			if (typeof keystone.get('signout redirect') === 'string') {
				return res.redirect(keystone.get('signout redirect'));
			} else if (typeof keystone.get('signout redirect') === 'function') {
				return keystone.get('signout redirect')(req, res);
			} else {
				return res.redirect('/' + kadm.get('kadmPath') + '/signin?signedout');
			}
		});
	};
};
