/**
 * Created by kinfen on 16/1/19.
 * 处理所有后台路由
 */
var	express = require('express');
var kadm = require('../../../');
var keystone = kadm.getAdminPlus();
var initList = require("./middleware/initList")(keystone);
var path = require('path');

var rbacManager = require('../../../core/acl/RBACManager');
var {
	routerCheckWithModel,
	routerCheckWithParamName,
} = require('../../../core/acl/RBACManager');

var _ = require('lodash');
var apiError = require('../api/middleware/apiError');
var logError = require('../api/middleware/logError')

exports = module.exports = function() {
	var router = express.Router();

	routerCheckWithModel = routerCheckWithModel.bind(rbacManager)
	routerCheckWithParamName = routerCheckWithParamName.bind(rbacManager)
	// bindPermissionToRequest = bindPermissionToRequest.bind(rbacManager);
	// #1: Session API

	let AdminRender = require('./middleware/adminRender');
	router.all('/', AdminRender(keystone));
	router.all('/list/:model', routerCheckWithParamName('read', 'model'), initList(), AdminRender(keystone));
	router.all('/item/:model/:id', routerCheckWithParamName('read', ['id', 'model']), initList(), AdminRender(keystone));

	/**
	 *
	 */

	router.post('/api2/upload/', require('../api/upload'));

	router.all('/api2/getpermissions/', require('../api/auth/list'));
	router.all('/api2/setmodule/', routerCheckWithModel('setmodule', 'Role'), require('../api/auth/list'));
	router.all('/api2/setmodel/',routerCheckWithModel('setmodel', 'Role'),  require('../api/auth/list'));

	router.all('/api2/authroles/:model',routerCheckWithModel('add', 'UserRole'), initList(), require('../api/auth/list'));
	router.all('/api2/:model/tree', initList(), require('../api/tree'));
	router.all('/api2/:model/list', initList(), require('../api/list'));
	router.all('/api2/:model/:id?', routerCheckWithParamName('read', ['id', 'model']), initList(), require('../api/item'));

	router.all('/innerapp/:app/:appid',routerCheckWithParamName( 'read', 'app'), AdminRender(keystone));
    router.all('/innerapp/:app/:appid/list/:model',
		routerCheckWithParamName( 'read', 'app'), 
        routerCheckWithParamName( 'read', 'model'), 
        AdminRender(keystone));

    router.all('/innerapp/:app/:appid/item/:model/:id',
		routerCheckWithParamName( 'read', 'app'), 
        routerCheckWithParamName( 'read', 'model'), 
        AdminRender(keystone));

	return router;
};
