var babelify = require('babelify');
var browserify = require('browserify');
var path = require('path');
var uglify = require('./uglifystream');
var basedir = path.resolve(__dirname + '/../admin/client/');


var str = require('string-to-stream');
var kadm = require('../');
var keystone = kadm.getAdminPlus();
var keystoneFields = require('../fields/fields');

function buildFieldTypesStream (fieldTypes) {
	var src = '';
	var types = Object.keys(fieldTypes);
	['Column', 'Field', 'Filter'].forEach(function (i) {
		src += 'exports.' + i + 's = {\n';
		types.forEach(function (type) {
			if (typeof fieldTypes[type] !== 'string') return;
			// console.log(`${type}: ${keystoneFields[i][type]}`);
			src += `${type}: ${keystoneFields[i][type]}`
			// src += `${type}: require("../fields/types/${type}/${fieldTypes[type]}${i}"),\n`;
		});
		src += '};\n';
	});
	return str(src);
}
var b = browserify({
	basedir,
});
b.require(buildFieldTypesStream(kadm.fieldTypes), { expose: 'FieldTypes' });

var packages = require('../admin/client/prebuild/packages');
b = b.transform(babelify);
b.exclude('FieldTypes');
b.exclude('antdlib');
b.exclude('kadm-component');
b.exclude('kadm-redux-mng');
packages.forEach(function (i) {
	b.exclude(i);
});

if (process.env.NODE_ENV === 'production'){
	uglify(b).pipe(process.stdout);
} else {
	b.bundle().pipe(process.stdout);
}

