/**
 * Created by kinfen on 2017/5/16.
 */

var Adapter = require('./Adapter');
var ACL = require("acl");
var kadm = require("../../index");
var keystone = kadm.getAdminPlus();
class AclAdapter extends Adapter{
	constructor(){
		super();
		this.acl = new ACL(new ACL.mongodbBackend(keystone.mongoose.connections[0].db, 'acl_'));
	}
	adapterInstance(){
		return this.acl;
	}
	allow( roles, resources, permissions, cb ){
		this.acl.allow( roles, resources, permissions, (err) =>{
			if (cb)
				cb(err)
		});
	}
	addRole(role, cb){
		this.acl.addUserRoles(null, role, (err)=>{
			if (cb)
				cb(err)
		});
	}
	addUserRoles(userId, roles, cb){
		this.acl.addUserRoles(userId, roles, (err)=>{
			if (cb)
				cb(err)
		});
	}
	removeUserRoles(userId, roles, cb){
		this.acl.removeUserRoles(userId, roles, (err)=>{
			if (cb)
				cb(err)
		})
	}
	userRoles(userId, cb){
		return this.acl.userRoles(userId, (err, roles)=>{
			if (cb)
				cb(err, roles)
		});
	}
	roleUsers(rolename, cb){
		this.acl.roleUsers(rolename, (err, users)=>{
			if (cb)
				cb(err, users)
		});
	}
	hasRole(userId, rolename, cb){
		this.acl.hasRole(userId, rolename, (err, hasRole)=>{
			if (cb)
				cb(err, hasRole)
		});
	}
	addRoleParents(role, parents, cb){
		this.acl.addRoleParents(role, parents, (err)=>{
			if (cb)
				cb(err)
		});
	}
	removeRoleParents( role, parents, cb){
		this.acl.removeRoleParents(role, parents, (err)=>{
			if (cb)
				cb(err)
		});
	}
	removeRole(  role, cb){
		this.acl.removeRole(role, (err)=>{
			if (cb)
				cb(err)
		});
	}
	removeResource( resource, cb){
		this.acl.removeResource(resource, (err)=>{
			if (cb)
				cb(err)
		});
	}
	removeAllow( role, resources, permissions, cb ){
		this.acl.removeAllow( role, resources, permissions, (err) =>{
			if (cb)
				cb(err)
		});
	}
	allowedPermissions( userId, resources, cb ){
		this.acl.allowedPermissions( userId, resources,(err, obj) =>{
			if (cb)
				cb(err, obj)
		});
	}
	isAllowed( userId, resource, permissions, cb ){
		this.acl.isAllowed( userId, resource, permissions, (err, allowed) =>{
			if (cb)
				cb(err, allowed)
		});
	}
	areAnyRolesAllowed( roles, resource, permissions,cb ){
		this.acl.areAnyRolesAllowed(  roles, resource, permissions,(err, allowed)=>{
			if (cb)
				cb(err, allowed)
		});
	}
	whatResources( role, cb ){
		this.acl.whatResources( role, (err, resources)=>{
			if (cb)
				cb(err, resources)
		});
	}
	middleware(){
		//TODO need to fix;
		console.log('continue')
	}
}
exports = module.exports =  AclAdapter;

