import React from 'react';
import { findDOMNode } from 'react-dom';
import {
    Button
} from 'antdlib'
class SegmentedControl extends React.Component{
    constructor(props){
        super(props);
        this.state = {
            options:this.props.options,
            value:this.props.defaultValue,
        }
    }
    onClick(value){
        this.setState({
            value,
        });
        if (this.props.onChange){
            
            this.props.onChange(value);
        }
    }
    renderSegmentedControl(){
        const style = {
            width:(100 / (this.props.options.length >= 1 ? this.props.options.length : 1)) + '%',
        }
        return _.map(this.state.options, (o) => {

           return <Button 
           style={style} 
           key={o.label} 
           data-value={o.value}
           type={o.value == this.state.value ? 'primary' : 'default'}
           onClick={(e) => {
                this.onClick(o.value);
           }}
           >{o.label}</Button>
        })
    }
    render(){
        return (
            <div style={{
                border: "1px solid #cccccc",
                padding: "1px",
                lineHeight:'0px',
            }}>
                <Button.Group style={{
                    width:'100%'
                }}>
                    {this.renderSegmentedControl()}
                </Button.Group>
            </div>
        )
    }
} 
export default SegmentedControl;