var FieldType = require('../Type');
var TextType = require('../text/TextType');
var util = require('util');
var utils = require('keystone-utils');

/**
 * Text FieldType Constructor
 * @extends Field
 * @api public
 */
function antdsicon (list, path, options) {
	this._nativeType = String;
	this._underscoreMethods = ['format', 'crop'];
	this.height = options.height || 90;
	this.multiline = true;
	this._properties = ['height', 'multiline'];
	antdsicon.super_.call(this, list, path, options);
}
antdsicon.properName = 'AntdsIcon';
util.inherits(antdsicon, FieldType);


antdsicon.prototype.validateInput = TextType.prototype.validateInput;
antdsicon.prototype.validateRequiredInput = TextType.prototype.validateRequiredInput;

/* Inherit from TextType prototype */
antdsicon.prototype.addFilterToQuery = TextType.prototype.addFilterToQuery;
antdsicon.prototype.crop = TextType.prototype.crop;

/**
 * Formats the field value
 * @api public
 */
antdsicon.prototype.format = function (item) {
	return utils.textToHTML(item.get(this.path));
};

/* Export Field Type */
module.exports = antdsicon;
