import React from 'react';
import Field from '../Field';
import Checkbox from '../../components/Checkbox';
import {Switch} from 'antdlib';
const NOOP = () => {};

module.exports = Field.create({
	displayName: 'BooleanField',
	statics: {
		type: 'Boolean',
	},
	propTypes: {
		indent: React.PropTypes.bool,
		label: React.PropTypes.string,
		onChange: React.PropTypes.func.isRequired,
		path: React.PropTypes.string.isRequired,
		value: React.PropTypes.bool,
	},
	componentWillMount(){
		this.state = {
			value:this.props.value
		}
	},
	valueChanged (value) {
		//this.props.onChange({
		//	path: this.props.path,
		//	value: value,
		//});
		//var param = {
		//	[this.getInputName(this.props.path)]:value,
		//	['fake-' + this.getInputName(this.props.path)]:value,
		//};
		//this.props.form.setFieldsValue(param);


	},
	renderFormInput () {
		if (!this.shouldRenderField()) return;

		return (
			<input
				name={this.getInputName(this.props.path)}
				type="hidden"
			/>
		);
	},
	renderField(){
		const { indent, value, label, path } = this.props;
		const name = this.getInputName(this.props.path);
		const stateValue = this.props.form.getFieldValue(name);

			return (

					<Switch
						name={name}
						defaultChecked = {value}
						checked={stateValue}
						//onChange={(this.shouldRenderField() && this.valueChanged.bind(this)) || NOOP}
						disabled={!this.shouldRenderField()}
						size="large"
					/>



			);
	}
});
