
import Field from '../Field';
import React from 'react';
import ColorPicker from '../../../lib/ui/colorpicker'
import _ from 'lodash';
import reactCSS from 'reactcss';

import {Input} from "antdlib";

const ColorField = Field.create({
	displayName: 'ColorField',
	statics: {
		type: 'Color',
	},
	propTypes: {
		onChange: React.PropTypes.func,
		path: React.PropTypes.string,
		value: React.PropTypes.string,
	},


	// updateValue (value) {
	// 	this.props.onChange({
	// 		path: this.props.path,
	// 		value: value,
	// 	});
	// },
	// handleInputChange (event) {
	// 	var newValue = event.target.value;
	// 	if (/^([0-9A-F]{3}){1,2}$/.test(newValue)) {
	// 		newValue = '#' + newValue;
	// 	}
	// 	if (newValue === this.props.value) return;
    //
	// 	this.updateValue(newValue);
	// },
	// handleClick () {
	// 	this.setState({ displayColorPicker: !this.state.displayColorPicker });
	// },
	// handleClose () {
	// 	this.setState({ displayColorPicker: false });
	// },
	// handlePickerChange (color) {
	// 	var newValue = color.hex;
    //
	// 	if (newValue === this.props.value) return;
    //
	// 	this.updateValue(newValue);
	// },
	// renderSwatch () {
	// 	const className = `${css(classes.swatch)} e2e-type-color__swatch`;
    //
	// 	return (this.props.value) ? (
	// 		<span
	// 			className={className}
	// 			style={{ backgroundColor: this.props.value }}
	// 		/>
	// 	) : (
	// 		<span
	// 			className={className}
	// 			dangerouslySetInnerHTML={{ __html: transparentSwatch }}
	// 		/>
	// 	);
	// },
	handleChange(color){
		const hex = color.hex;
		const name = this.getInputName(this.props.path)
		this.props.form.setFieldsValue({
			[name]: hex
		});
	},
	renderField () {
		const color = this.props.form.getFieldValue(this.getInputName(this.props.path));
		const hex = color.hex;
		let swatchStyle = _.assign({}, classes.swatch, {backgroundColor:color});
		return (
			<div name={this.getInputName(this.props.path)}>
				<ColorPicker  color={color} onChange={this.handleChange.bind(this)}
							 style={{width:200}}
				>
					<Input  type="text" value={color} size={this.fieldSize} />
					<div style={swatchStyle}></div>
				</ColorPicker>
			</div>
		);
	},
});

/* eslint quote-props: ["error", "as-needed"] */
const classes = reactCSS({
	"default":{
		swatch: {
			position:"absolute",
			borderRadius: 1,
			boxShadow: 'inset 0 0 0 1px rgba(0,0,0,0.1)',
			display: 'block',
			height: '15px',
			width: '15px',
			top:'12px',
			right:'12px',
		},
	}

});

module.exports = ColorField;
