import Field from '../Field';
import moment from 'moment';
import React from 'react';

import {DatePicker, Input} from 'antdlib';
/*
TODO: Implement yearRange Prop, or deprecate for max / min values (better)
*/

const DEFAULT_INPUT_FORMAT = 'YYYY-MM-DD';
module.exports = Field.create({
	displayName: 'DateField',
	statics: {
		type: 'Date',
		showTime:true,
	},
	propTypes: {
		formatString: React.PropTypes.string,
		inputFormat: React.PropTypes.string,
		label: React.PropTypes.string,
		note: React.PropTypes.string,
		onChange: React.PropTypes.func,
		path: React.PropTypes.string,
		value: React.PropTypes.string,
	},

	getDefaultProps () {
		return {
			formatString: DEFAULT_INPUT_FORMAT,
			inputFormat: DEFAULT_INPUT_FORMAT,
		};
	},
	// valueChanged ({ value }) {
	// 	this.props.onChange({
	// 		path: this.props.path,
	// 		value: value,
	// 	});
	// },
	getInitValue(){
		const {  value,   defaultValue} = this.props;
		return moment(value || defaultValue)
	},
	moment (value) {
		var m = moment(value);
		if (this.props.isUTC) m.utc();
		return m;
	},
	isValid (value) {
		return this.moment(value, this.inputFormat).isValid();
	},
	format (value) {
		return value ? this.moment(value).format(this.props.formatString) : '';
	},
	//setToday () {
	//	this.valueChanged({
	//		value: this.moment(new Date()).format(this.props.inputFormat),
	//	});
	//},
	renderValue () {
		return (

			<Input disabled>
				{this.format(this.props.value)}
			</Input>
		);
	},
	renderField () {
		let value = this.moment(this.props.value);
		value = this.props.value && value.isValid()
			? value.format(this.props.inputFormat)
			: this.props.value;

		return (

			<DatePicker
				size='large'
				format={this.props.inputFormat}
				placeholder="Select Time"

			/>

			// <InputGroup>
			// 	<InputGroup.Section grow>
			// 		<DateInput
			// 			format={this.props.inputFormat}
			// 			name={this.getInputName(this.props.path)}
			// 			onChange={this.valueChanged}
			// 			ref="dateInput"
			// 			value={value}
			// 		/>
			// 	</InputGroup.Section>
			// 	<InputGroup.Section>
			// 		<Button onClick={this.setToday}>Today</Button>
			// 	</InputGroup.Section>
			// </InputGroup>
		);
	},

});

//const dateFormat = 'YYYY/MM/DD';
//const monthFormat = 'YYYY/MM';
//ReactDOM.render(
//	<div>
//		<DatePicker defaultValue={moment('2015/01/01', dateFormat)} format={dateFormat} />
//		<br />
//		<MonthPicker defaultValue={moment('2015/01', monthFormat)} format={monthFormat} />
//		<br />
//		<RangePicker
//			defaultValue={[moment('2015/01/01', dateFormat), moment('2015/01/01', dateFormat)]}
//			format={dateFormat}
//		/>
//	</div>
//	, mountNode);
