import Field from '../Field';
import React, { PropTypes } from 'react';
import {AutoComplete} from 'antdlib';

/*
	TODO:
	- gravatar
	- validate email address
 */

module.exports = Field.create({
	displayName: 'EmailField',
	propTypes: {
		path: PropTypes.string.isRequired,
		value: PropTypes.string,
	},
	statics: {
		type: 'Email',
	},
	handleChange (value){
		this.setState({
			dataSource: !value || value.indexOf('@') >= 0 ? [] : [
				`${value}@gmail.com`,
				`${value}@163.com`,
				`${value}@qq.com`,
			],
		})
	},
	renderField () {
		return (
			<AutoComplete
				name={this.getInputName(this.props.path)}
				type="email"
				dataSource={this.state.dataSource}
				onChange={this.handleChange.bind(this)}
			/>
		);
	},
});
