import Touchable from '../Field';
import {
	OverlayTrigger,
	Popover,
	Glyphicon,
	ButtonGroup,
	Button,
} from 'react-bootstrap'
import React from 'react';

module.exports = Touchable.create({
	displayName: 'GlyphsIcon',
	statics: {
		type: 'glyphsicon',

	},
	componentWillMount(){
		this.state = {
			icon:this.props.value,
			defaultIcon:this.props.value,
		}
	},
	componentDidMount(){
		// console.log(this.refs.btn)
		// $(this.refs.btn).popover();
		// $('[data-toggle="popover"]').popover();
	},
	handleClick(e){
		var str = $(e.currentTarget).data("glyph");
		this.setState({
			icon:str,
		});
		this.props.onChange({
			path: this.props.path,
			value: str,
		});
	},
	renderCssBtns(){

		let classStr = [
			"",
			"asterisk",
			"plus",
			"euro",
			"eur",
			"minus",
			"cloud",
			"envelope",
			"pencil",
			"glass",
			"music",
			"search",
			"heart",
			"star",
			"star-empty",
			"user",
			"film",
			"th-large",
			"th",
			"th-list",
			"ok",
			"remove",
			"zoom-in",
			"zoom-out",
			"off",
			"signal",
			"cog",
			"trash",
			"home",
			"file",
			"time",
			"road",
			"download-alt",
			"download",
			"upload",
			"inbox",
			"play-circle",
			"repeat",
			"refresh",
			"list-alt",
			"lock",
			"flag",
			"headphones",
			"volume-off",
			"volume-down",
			"volume-up",
			"qrcode",
			"barcode",
			"tag",
			"tags",
			"book",
			"bookmark",
			"print",
			"camera",
			"font",
			"bold",
			"italic",
			"text-height",
			"text-width",
			"align-left",
			"align-center",
			"align-right",
			"align-justify",
			"list",
			"indent-left",
			"indent-right",
			"facetime-video",
			"picture",
			"map-marker",
			"adjust",
			"tint",
			"edit",
			"share",
			"check",
			"move",
			"step-backward",
			"fast-backward",
			"backward",
			"play",
			"pause",
			"stop",
			"forward",
			"fast-forward",
			"step-forward",
			"eject",
			"chevron-left",
			"chevron-right",
			"plus-sign",
			"minus-sign",
			"remove-sign",
			"ok-sign",
			"question-sign",
			"info-sign",
			"screenshot",
			"remove-circle",
			"ok-circle",
			"ban-circle",
			"arrow-left",
			"arrow-right",
			"arrow-up",
			"arrow-down",
			"share-alt",
			"resize-full",
			"resize-small",
			"exclamation-sign",
			"gift",
			"leaf",
			"fire",
			"eye-open",
			"eye-close",
			"warning-sign",
			"plane",
			"calendar",
			"random",
			"comment",
			"magnet",
			"chevron-up",
			"chevron-down",
			"retweet",
			"shopping-cart",
			"folder-close",
			"folder-open",
			"resize-vertical",
			"resize-horizontal",
			"hdd",
			"bullhorn",
			"bell",
			"certificate",
			"thumbs-up",
			"thumbs-down",
			"hand-right",
			"hand-left",
			"hand-up",
			"hand-down",
			"circle-arrow-right",
			"circle-arrow-left",
			"circle-arrow-up",
			"circle-arrow-down",
			"globe",
			"wrench",
			"tasks",
			"filter",
			"briefcase",
			"fullscreen",
			"dashboard",
			"paperclip",
			"heart-empty",
			"link",
			"phone",
			"pushpin",
			"usd",
			"gbp",
			"sort",
			"sort-by-alphabet",
			"sort-by-alphabet-alt",
			"sort-by-order",
			"sort-by-order-alt",
			"sort-by-attributes",
			"sort-by-attributes-alt",
			"unchecked",
			"expand",
			"collapse-down",
			"collapse-up",
			"log-in",
			"flash",
			"log-out",
			"new-window",
			"record",
			"save",
			"open",
			"saved",
			"import",
			"export",
			"send",
			"floppy-disk",
			"floppy-saved",
			"floppy-remove",
			"floppy-save",
			"floppy-open",
			"credit-card",
			"transfer",
			"cutlery",
			"header",
			"compressed",
			"earphone",
			"phone-alt",
			"tower",
			"stats",
			"sd-video",
			"hd-video",
			"subtitles",
			"sound-stereo",
			"sound-dolby",
			"sound-5-1",
			"sound-6-1",
			"sound-7-1",
			"copyright-mark",
			"registration-mark",
			"cloud-download",
			"cloud-upload",
			"tree-conifer",
			"tree-deciduous",
			"cd",
			"save-file",
			"open-file",
			"level-up",
			"copy",
			"paste",
			"alert",
			"equalizer",
			"king",
			"queen",
			"pawn",
			"bishop",
			"knight",
			"baby-formula",
			"tent",
			"blackboard",
			"bed",
			"apple",
			"erase",
			"hourglass",
			"lamp",
			"duplicate",
			"piggy-bank",
			"scissors",
			"bitcoin",
			"btc",
			"xbt",
			"yen",
			"jpy",
			"ruble",
			"rub",
			"scale",
			"ice-lolly",
			"ice-lolly-tasted",
			"education",
			"option-horizontal",
			"option-vertical",
			"menu-hamburger",
			"modal-window",
			"oil",
			"grain",
			"sunglasses",
			"text-size",
			"text-color",
			"text-background",
			"object-align-top",
			"object-align-bottom",
			"object-align-horizontal",
			"object-align-left",
			"object-align-vertical",
			"object-align-right",
			"triangle-right",
			"triangle-left",
			"triangle-bottom",
			"triangle-top",
			"console",
			"superscript",
			"subscript",
			"menu-left",
			"menu-right",
			"menu-down",
			"menu-up"
		];
		let glyphs = _.map(classStr, (str) => {
			if (str == "")
				return <Button onClick={this.handleClick.bind(this)}>
					<span>&nbsp;&nbsp;&nbsp;</span>
				</Button>
			else
				return (

						<Button data-glyph={str} onClick={this.handleClick.bind(this)}>
							<Glyphicon key={str} glyph={str}/>
						</Button>
					)
		});

		return (
			<Popover title="请选择一个icon">
				<div className="fields-glyphicon-popover-container">
					<ButtonGroup>
						{glyphs}
					</ButtonGroup>
				</div>


			</Popover>
		)
	},
	renderField () {
		const { autoFocus, value, inputProps } = this.props;
		var icon = value;
		if (value != this.state.icon){
			if ( value == this.state.defaultIcon){
				icon = this.state.icon;
			}
			else{
				icon = value;
			}
		}
		return (
			<OverlayTrigger trigger="click" placement="bottom" rootClose overlay={this.renderCssBtns()}>
				<Button
						role="button"
						data-toggle="dropdown"
						aria-haspopup="true"
						aria-expanded="false"
				>
					<Glyphicon glyph={value}/>
					<input
						name={this.getInputName(this.props.path)}
						value={value}
						onChange={this.valueChanged.bind(this)}
						type="hidden"
					/>
				</Button>


			</OverlayTrigger>



		);
	},
	renderValue () {
		return <Glyph icon="arrow-down"/>
		// return <FormInput noedit>{this.props.value}</FormInput>;
	},
	// renderField () {
	// 	const { height, path, style, value } = this.props;
    //
	// 	const styles = {
	// 		height: height,
	// 		...style,
	// 	};
	// 	return (
	// 		<FormInput
	// 			autoComplete="off"
	// 			multiline
	// 			name={this.getInputName(path)}
	// 			onChange={this.valueChanged}
	// 			ref="focusTarget"
	// 			style={styles}
	// 			value={value}
	// 		/>
	// 	);
	// },
});
