var FieldType = require('../Type');
var TextType = require('../text/TextType');
var util = require('util');
var utils = require('keystone-utils');

/**
 * Text FieldType Constructor
 * @extends Field
 * @api public
 */
function glyphsicon (list, path, options) {
	this._nativeType = String;
	this._underscoreMethods = ['format', 'crop'];
	this.height = options.height || 90;
	this.multiline = true;
	this._properties = ['height', 'multiline'];
	glyphsicon.super_.call(this, list, path, options);
}
glyphsicon.properName = 'GlyphsIcon';
util.inherits(glyphsicon, FieldType);


glyphsicon.prototype.validateInput = TextType.prototype.validateInput;
glyphsicon.prototype.validateRequiredInput = TextType.prototype.validateRequiredInput;

/* Inherit from TextType prototype */
glyphsicon.prototype.addFilterToQuery = TextType.prototype.addFilterToQuery;
glyphsicon.prototype.crop = TextType.prototype.crop;

/**
 * Formats the field value
 * @api public
 */
glyphsicon.prototype.format = function (item) {
	return utils.textToHTML(item.get(this.path));
};

/* Export Field Type */
module.exports = glyphsicon;
