import _ from 'lodash';
import Field from '../Field';
import React from 'react';
import TinyMce from 'react-tinymce';
import {Input} from 'antdlib';
const { TextArea } = Input;
/**
 * TODO:
 * - Remove dependency on underscore
 */

var lastId = 0;

function getId () {
	return 'keystone-html-' + lastId++;
}

// Workaround for #2834 found here https://github.com/tinymce/tinymce/issues/794#issuecomment-203701329
function removeTinyMCEInstance (editor) {
	var oldLength = tinymce.editors.length;
	tinymce.remove(editor);
	if (oldLength === tinymce.editors.length) {
		tinymce.editors.remove(editor);
	}
}

module.exports = Field.create({

	displayName: 'HtmlField',
	statics: {
		type: 'Html',
	},

	getInitialState () {
		return {
			id: getId(),
			isFocused: false,
		};
	},

	initWysiwyg () {
		if (!this.props.wysiwyg) return;

		var self = this;
		var opts = this.getOptions();

		opts.setup = function (editor) {
			self.editor = editor;
			editor.on('change', self.valueChanged);
			editor.on('focus', self.focusChanged.bind(self, true));
			editor.on('blur', self.focusChanged.bind(self, false));
		};

		this._currentValue = this.props.value;
		tinymce.init(opts);
	},

	componentDidUpdate (prevProps, prevState) {
		//if (prevState.isCollapsed && !this.state.isCollapsed) {
		//	this.initWysiwyg();
		//}
        //
		//if (!_.isEqual(this.props.currentDependencies, prevProps.currentDependencies)) {
		//	if (_.isEqual(prevProps.dependsOn, prevProps.currentDependencies)) {
		//		var instance = tinymce.get(prevState.id);
		//		if (instance) {
		//			removeTinyMCEInstance(instance);
		//		}
		//	}
        //
		//	if (_.isEqual(this.props.dependsOn, this.props.currentDependencies)) {
		//		this.initWysiwyg();
		//	}
		//}
	},

	componentDidMount () {
		this.initWysiwyg();
	},

	componentWillReceiveProps (nextProps) {
		//if (this.editor && this._currentValue !== nextProps.value) {
		//	this.editor.setContent(nextProps.value);
		//}
	},

	focusChanged (focused) {
		this.setState({
			isFocused: focused,
		});
	},

	//valueChanged  (event) {
	//	var content;
	//	if (this.editor) {
	//		content = this.editor.getContent();
	//	} else {
	//		content = event.target.value;
	//	}
    //
	//	this._currentValue = content;
	//	this.props.onChange({
	//		path: this.props.path,
	//		value: content,
	//	});
	//},

	getOptions () {
		var options = Object.assign(
				{},
				KAdm.wysiwyg.options,
				this.props.wysiwyg
		);
		return options;


		//var toolbar = options.overrideToolbar ? '' : 'bold italic | alignleft aligncenter alignright | bullist numlist | outdent indent | removeformat | link ';
		//var i;



		//var opts = {
		//	selector: '#' + this.state.id,
		//	toolbar: toolbar,
		//	plugins: plugins,
		//	menubar: options.menubar || false,
		//	skin: options.skin || 'keystone',
		//};
        //
		//if (this.shouldRenderField()) {
		//	opts.uploadimage_form_url = options.enableS3Uploads ? Keystone.adminPath + '/api/s3/upload' : Keystone.adminPath + '/api/cloudinary/upload';
		//} else {
		//	Object.assign(opts, {
		//		mode: 'textareas',
		//		readonly: true,
		//		menubar: false,
		//		toolbar: 'code',
		//		statusbar: false,
		//	});
		//}

		//if (options.additionalOptions) {
		//	Object.assign(opts, options.additionalOptions);
		//}
	},

	getFieldClassName () {
		var className = this.props.wysiwyg ? 'wysiwyg' : 'code';
		return className;
	},
	handleEditorChange(e){
		const name = this.getInputName(this.props.path);
		const content = e.target.getContent();
		this.props.form.setFieldsValue({
			[name]:content,
		})
		//console.log('Content was updated:', e.target.getContent());
	},
	renderField () {
		const name = this.getInputName(this.props.path);
		const value = this.props.form.getFieldValue(name);
		const ops = this.getOptions();
		return (
			<div>
				<TinyMce
					{...{
							content:value,
							config:{
								...ops,
							},
							onChange:this.handleEditorChange.bind(this),
						}
					}
				>
				</TinyMce >
				<Input type="hidden" name={name}/>
			</div>

			//<div className={className}>
			//	<FormInput multiline style={style} onChange={this.valueChanged} id={this.state.id} className={this.getFieldClassName()} name={this.getInputName(this.props.path)} value={this.props.value} />
			//</div>
		);
	},

	renderValue () {
		return <FormInput multiline noedit value={this.props.value} />;
	},

});
