import Field from '../Field';
import React from 'react';
import _ from 'lodash';


/**
 * TODO:
 * - Custom path support
 */
import {Select, Input} from "antdlib";
const Option = Select.Option;


module.exports = Field.create({

	displayName: 'ModuleSelectField',
	statics: {
		type: 'ModuleSelect',
	},

	renderValue () {
		var selected = this.props.ops.find(option => option.value === this.props.value);
		return <Input disabled>{selected ? selected.label : null}</Input>;
	},
	getOpsList(){
		var list = _.filter(KAdm.lists, (o) => o.isInnerApps || !this.props.innerAppsLimit);

		var opsList = _.map(list, (value, key) => {
			return <Select.Option key={key} value={value.key}>{value.key}</Select.Option>;
		});
		return opsList
	},
	renderField () {
		// TODO: This should be natively handled by the Select component
		
		var opsList = this.getOpsList();
		const { autoFocus, inputProps, path } = this.props;
		return (
			<Select {...{
				...inputProps,
				autoFocus,
				name: this.getInputName(path),
				size:'large',
				onChange: this.valueChanged,
			}}>
				{opsList}
			</Select>
		);
	},
	
});
