import React from 'react';
import Field from '../Field';
import {
	Form,
	Input,
	Icon,
	Button,
} from 'antdlib';

module.exports = Field.create({

	displayName: 'PasswordField',
	statics: {
		type: 'Password',
	},

	getInitialState () {


		return {
			passwordIsSet: this.props.value ? true : false,
			showChangeUI: this.props.mode === 'create' ? true : false,
			password: '',
			confirm: '',
		};
	},
	getValidateRules(){
		return [{ required:true,
			validator: (rule, value, callback) => {
				//const name = this.getInputName(this.props.path);
				const value1 = this.refs.pwd1.input.value;
				const value2 = this.refs.pwd2.input.value;
				if (value1 && value1 != value2)
				{
					callback('重新输入密码进行校验');
					return;
				}
				callback();
		} }];
	},
	showChangeUI () {
		this.setState({
			showChangeUI: true,
		});
	},
    //
	onCancel () {
		this.setState({
			showChangeUI: false,
		});
	},
    //
	renderValue () {
		const pwd = this.props.form.getFieldValue(this.getInputName(this.props.path));
		return <Input
			type="password"
			size={this.fieldSize}
			disabled
			value={pwd.length > 0 ? "******" : ""}
		/>
		//return <FormInput noedit>{this.props.value ? 'password set' : 'password not set'}</FormInput>;
	},
	shouldUseFieldDecorator(){
		return this.state.showChangeUI;
	},
	renderField () {
		const name = this.getInputName(this.props.path)
		var node;
		if (this.state.showChangeUI){
			node = (
				<div>
						<p>
							<Input
								name={name}
								prefix={<Icon type="lock" style={{ fontSize: 13 }} />}
								type="password"
								size={this.fieldSize}
								placeholder="Password"
								ref="pwd1"
							/>
						</p>
						<p>
							<Input
								prefix={<Icon type="lock" style={{ fontSize: 13 }} />}
								type="password"
								size={this.fieldSize}
								placeholder="Confirm Password"
								ref="pwd2"
							/>
						</p>
						<p>
							{this.state.passwordIsSet ? <Button size={this.fieldSize} onClick={this.onCancel}>取消</Button> : null}
						</p>

					</div>
			);
		}
		else {
			node = this.renderChangeButton();
		}

		return node;
	},
    //
	renderChangeButton () {
		var label = this.state.passwordIsSet ? '修改密码' : '设置密码';
		return (

				<Button
					type="button"
					size={this.fieldSize}
					onClick={this.showChangeUI.bind(this)}

				>
					{label}
				</Button>


		);
	},

});
