import React from 'react';
// import ItemsTableCell from '../../components/ItemsTableCell';
// import ItemsTableValue from '../../components/ItemsTableValue';
import { Link } from 'react-router';
import {Tag} from 'antdlib';

const moreIndicatorStyle = {
	color: '#bbb',
	fontSize: '.8rem',
	fontWeight: 500,
	marginLeft: 8,
};

var RelationshipColumn = React.createClass({
	displayName: 'RelationshipColumn',
	propTypes: {
		col: React.PropTypes.object,
		data: React.PropTypes.object,
	},
	renderMany (value) {
		if (!value || !value.length) return;
		const refList = this.props.col.field.refList;
		const items = [];
		for (let i = 0; i < 3; i++) {
			if (!value[i]) break;
			if (i) {
				items.push(<span key={'comma' + i}>, </span>);
			}
			items.push(
				<Tag>
					{value[i].name}
				</Tag>
			);
		}
		if (value.length > 3) {
			items.push(<span key="more" style={moreIndicatorStyle}>[...{value.length - 3} more]</span>);
		}
		return (
			<div>
				{items}
			</div>
		);
	},
	renderValue (value) {
		if (!value) return;
		const refList = this.props.col.field.refList;
		return (
			<Tag>
				{value.name}
			</Tag>
		);
	},
	render () {
		const value = this.props.data.fields[this.props.col.path];
		const many = this.props.col.field.many;
		return (
			<div>
				{many ? this.renderMany(value) : this.renderValue(value)}
			</div>
		);
	},
});

module.exports = RelationshipColumn;
