import Field from '../Field';
import React from 'react';
import _ from 'lodash';


/**
 * TODO:
 * - Custom path support
 */
import {Select, Input} from "antdlib";
const Option = Select.Option;


module.exports = Field.create({

	displayName: 'SelectField',
	statics: {
		type: 'Select',
	},

	valueChanged (newValue) {
		// TODO: This should be natively handled by the Select component
		if (this.props.numeric && typeof newValue === 'string') {
			newValue = newValue ? Number(newValue) : undefined;
		}
		this.props.onChange({
			path: this.props.path,
			value: newValue,
		});
	},

	renderValue () {
		var selected = this.props.ops.find(option => option.value === this.props.value);
		return <Input disabled>{selected ? selected.label : null}</Input>;
	},

	getOpsList(){
		var ops = (this.props.numeric) ? this.props.ops.map(function (i) { return { label: i.label, value: i.value}; }) : this.props.ops;
		var opsList = _.map(ops, (o) => {
			return <Select.Option key={o.value} value={o.value}>{o.label}</Select.Option>;
		});
		return opsList
	},
	renderField () {
		// TODO: This should be natively handled by the Select component
		
		var opsList = this.getOpsList();
		const { autoFocus, inputProps, path } = this.props;
		return (
			<Select {...{
				...inputProps,
				autoFocus,
				name: this.getInputName(path),
				size:'large',
				onChange: this.valueChanged,
			}}>
				{opsList}
			</Select>
		);
	},

});
