/**
 * Created by kinfen on 2017/11/16.
 */
import React from 'react';
import Card from "antd/lib/card";
import _ from 'lodash';
import ReactCSSTransitionGroup from 'react-addons-css-transition-group';


class Picker extends React.Component{


	state = {
		showPicker: false,
		valignMode:"top",
	}
	props = {
		style:{
			width:200,
			height:400,
		}
	}
	handleFocusInput(){
		this.setState({
			showPicker:true,
		})
	}

	handleClose(){
		this.setState({
			showPicker:false,
		})
	}
	renderPickerContent(){
		return null;
	}
	renderCardNode(){

		var inputStyles = {
			input: {
				border: "none",
			},
			label: {
				fontSize: '12px',
				color: '#999',
			},
		};

		let cover = {
				position: 'fixed',
				top: '0px',
				right: '0px',
				bottom: '0px',
				left: '0px',
			};

		return (
				<Card
					style={{
						position:"absolute",
						width:this.props.style.width + 4,
						title:"title",
						left:-2,
						top:-2,
						boxShadow: "0 1px 6px rgba(0,0,0,0.2)",
						borderRadius: 4,
						borderColor:"transparent",
						zIndex:999,
					}}
					bodyStyle={{ padding: 0 }}
				>
					<div
						style={cover}
						onClick={this.handleClose.bind(this)}
					>
					</div>
					{this.renderPickerContent()}
				</Card>


		)

	}
	render(){
		const cardNode = this.state.showPicker ? this.renderCardNode() : null;
		var style = _.assign(this.props.style, {
			position:"relative",
		});

		let scrH = document.body.scrollHeight;

		function getOffsetPoint(node){

			// var offsetTop = node.offsetTop;
			// var offsetLeft = node.offsetLeft;
			// if(node.offsetParent!=null){
			// 	const p = getOffsetPoint(node.offsetParent);
			// 	offsetLeft += p.x;
			// 	offsetTop += p.y;
			// }
			// return {x:offsetLeft, y:offsetTop};
		}
		// if (cardNode){
		// 	const offset = cardNode.getDOMNode();
		// 	console.log(offset);
		// }



		var transitionName = "kadm-picker-" + this.state.valignMode;


		return (
			<div
				{
					...this.props
				}
				{
					...{
						onFocus:this.handleFocusInput.bind(this),
						style:style
					}
				}
			>
				{this.props.children}
				<ReactCSSTransitionGroup
					{...{
						transitionName,
					}}
				>
					{cardNode}
				</ReactCSSTransitionGroup>
			</div>
		)
	}


}

export default Picker


