/**
 * Created by kinfen on 16/9/7.
 */

var kadm = require('../../');
var keystone = kadm.getAdminPlus(),
	Types = kadm.Field.Types;
config = require('../../config/config');

/**
 * User Model
 * ==========
 */

var Role = new keystone.List('Role', {
	schema:{
		code:{
			unique:true,
		}
	}
});

Role.add({
	name: { label:"角色名", type: String,  required: true, initial:true},
	code:{ label:"代码", type: Types.Key, initial:true , index:true, noedit:true,},
	parent:{ label:"父角色", type: Types.Relationship, ref: 'Role'},
	state:{label:"状态", type: Types.Select, numeric:true, options: config.global_states, default:config.GLOBAL_STATE_NORMAL.value },
	description:{label:"描述",  type: Types.Text, default:''},
});
Role.schema.post('save', function(doc) {
	if (!kadm.rbac){
		console.error('没有权限实例,角色权限未被创建')
		return;
	}
	kadm.rbac.rbac.createRole( doc.code, true, (err) => {
		if (err)
			console.log(err)
	});
});
Role.schema.post('remove', function(doc) {
	if (!kadm.rbac){
		console.error('没有权限实例,角色权限未被销毁')
		return;
	}
	kadm.rbac.rbac.removeByName( doc.code, (err) => {
		if (err)
			console.log(err)
	} );
});
Role.defaultColumns = 'name|100, code, description';
Role.defaultSort = '-name';
Role.register();
