var kadm = require('../../');
var keystone = kadm.getAdminPlus(),
	Types = kadm.Field.Types;
config = require('../../config/config');
/**
 * User Model
 * ==========
 */

var User = new keystone.List('User');

User.add({
	name: { type: Types.Name, required: true, index: true ,initial: true,},
	email: { type: Types.Email, initial: true, required: true, index: true },
	password: { type: Types.Password, initial: true, required: true },
	state:{label:"状态", type: Types.Select, numeric:true, options: config.global_states, default:config.GLOBAL_STATE_NORMAL.value },

});

User.schema.virtual('canAccessKeystone').get(function() {
	/*to match with the old keystone core User func, user.canAccessKeystone will never return false,
	user access control rely to acl module
	*/
	return true;
});

User.schema.post('save', function(doc) {
	// let id = doc.id;
	// let ListObj = keystone.lists['UserRole'];
	// var target = new ListObj.model();
	// let data = {
	// 	user:id,
	// 	role:[],
	// }
	// ListObj.updateItem(target, data, {
	// 	ignoreNoEdit: true,
	// 	user: doc._req_user,
	// },function (err) {
	// 	if (err) {
	// 		console.log(err);
	// 	}
	// });

});


/**
 * Registration
 */

User.defaultColumns = 'name, email, role';
User.defaultSort = '-name';
User.register();
